<?php
/**
 * The Modal Window for versions
 *
 * @package     ProjectHuddle
 * @subpackage  app/templates
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */
?>

<!-- Underscore Template -->
<script type="text/html" id='tmpl-versions-image'>
	<span class="ph-nav-thumb" style="background-image: url( {{ data.image.attributes.thumbnail }} );">
		<span class="ph-thumb-details">
			<span class="ph-thumb-detail ph-thumb-comment">
				<i class="ph-icon ion-chatbubble"></i> {{ data.image.attributes.comment_count }}
			</span>

			<span class="ph-thumb-detail ph-thumb-date">
				<i class="ph-icon ion-android-time"></i> {{ data.image.attributes.date }}
			</span>
		</span>
	</span>

	<span class="ph-thumb-title">
		<?php if ( 'off' != get_post_meta( $post->ID, 'ph_project_approval', true ) ) : ?>
			<# if ( data.image.attributes.approved ) { #>
				<i class="ph-icon ion-android-done ph-approval-indicator"></i>
			<# } #>
		<?php endif; ?>
		<span class="ph-thumb-name">
			{{ data.image.attributes.title }}
		</span>
	</span>

</script>