<?php
/**
 * Redirects to actual website comment on single page view
 *
 * Sets a cookie
 */
global $post;

// get page url from thread
$website_page = PHW()->page->get_item( $post->ID );

// get website ID
if ( $website_page['page_url'] ) {

	// user needs to login no matter what for beta
	if ( ! is_user_logged_in() ) :

		// get main content
		ph_get_template_part( 'content', 'login' );

	// password required
    elseif ( post_password_required() ) :

		// get main content
		ph_get_template_part( 'content', 'password' );

	// public
	else :
		wp_redirect( esc_url( $website_page['page_url'] ) );
		exit;
	endif;
}
?>
<html>
<head>
	<!-- make sure it's not indexed -->
	<meta name="robots" content="noindex, nofollow">
</head>
<body>
</body>
</html>