/*!
 Autosize 3.0.5
 license: MIT
 http://www.jacklmoore.com/autosize
 */
!function(e,t){if("function"==typeof define&&define.amd)define(["exports","module"],t);else if("undefined"!=typeof exports&&"undefined"!=typeof module)t(exports,module);else{var o={exports:{}};t(o.exports,o),e.autosize=o.exports}}(this,function(e,t){"use strict";function o(e){function t(){var t=window.getComputedStyle(e,null);"vertical"===t.resize?e.style.resize="none":"both"===t.resize&&(e.style.resize="horizontal"),l="content-box"===t.boxSizing?-(parseFloat(t.paddingTop)+parseFloat(t.paddingBottom)):parseFloat(t.borderTopWidth)+parseFloat(t.borderBottomWidth),n()}function o(t){var o=e.style.width;e.style.width="0px",e.offsetWidth,e.style.width=o,u=t,a&&(e.style.overflowY=t),n()}function n(){var t=e.style.height,n=document.documentElement.scrollTop,i=document.body.scrollTop,r=e.style.height;e.style.height="auto";var d=e.scrollHeight+l;if(0===e.scrollHeight)return void(e.style.height=r);e.style.height=d+"px",document.documentElement.scrollTop=n,document.body.scrollTop=i;var s=window.getComputedStyle(e,null);if(s.height!==e.style.height){if("visible"!==u)return void o("visible")}else if("hidden"!==u)return void o("hidden");if(t!==e.style.height){var a=document.createEvent("Event");a.initEvent("autosize:resized",!0,!1),e.dispatchEvent(a)}}var i=void 0===arguments[1]?{}:arguments[1],r=i.setOverflowX,d=void 0===r?!0:r,s=i.setOverflowY,a=void 0===s?!0:s;if(e&&e.nodeName&&"TEXTAREA"===e.nodeName&&!e.hasAttribute("data-autosize-on")){var l=null,u="hidden",v=function(t){window.removeEventListener("resize",n),e.removeEventListener("input",n),e.removeEventListener("keyup",n),e.removeAttribute("data-autosize-on"),e.removeEventListener("autosize:destroy",v),Object.keys(t).forEach(function(o){e.style[o]=t[o]})}.bind(e,{height:e.style.height,resize:e.style.resize,overflowY:e.style.overflowY,overflowX:e.style.overflowX,wordWrap:e.style.wordWrap});e.addEventListener("autosize:destroy",v),"onpropertychange"in e&&"oninput"in e&&e.addEventListener("keyup",n),window.addEventListener("resize",n),e.addEventListener("input",n),e.addEventListener("autosize:update",n),e.setAttribute("data-autosize-on",!0),a&&(e.style.overflowY="hidden"),d&&(e.style.overflowX="hidden",e.style.wordWrap="break-word"),t()}}function n(e){if(e&&e.nodeName&&"TEXTAREA"===e.nodeName){var t=document.createEvent("Event");t.initEvent("autosize:destroy",!0,!1),e.dispatchEvent(t)}}function i(e){if(e&&e.nodeName&&"TEXTAREA"===e.nodeName){var t=document.createEvent("Event");t.initEvent("autosize:update",!0,!1),e.dispatchEvent(t)}}var r=null;"undefined"==typeof window||"function"!=typeof window.getComputedStyle?(r=function(e){return e},r.destroy=function(e){return e},r.update=function(e){return e}):(r=function(e,t){return e&&Array.prototype.forEach.call(e.length?e:[e],function(e){return o(e,t)}),e},r.destroy=function(e){return e&&Array.prototype.forEach.call(e.length?e:[e],n),e},r.update=function(e){return e&&Array.prototype.forEach.call(e.length?e:[e],i),e}),t.exports=r});
( function( window, undefined ) {
	'use strict';

	/**
	 * Handles managing all events for whatever you plug it into. Priorities for hooks are based on lowest to highest in
	 * that, lowest priority hooks are fired first.
	 */
	var EventManager = function() {
		var slice = Array.prototype.slice;
		
		/**
		 * Maintain a reference to the object scope so our public methods never get confusing.
		 */
		var MethodsAvailable = {
			removeFilter : removeFilter,
			applyFilters : applyFilters,
			addFilter : addFilter,
			removeAction : removeAction,
			doAction : doAction,
			addAction : addAction
		};

		/**
		 * Contains the hooks that get registered with this EventManager. The array for storage utilizes a "flat"
		 * object literal such that looking up the hook utilizes the native object literal hash.
		 */
		var STORAGE = {
			actions : {},
			filters : {}
		};

		/**
		 * Adds an action to the event manager.
		 *
		 * @param action Must contain namespace.identifier
		 * @param callback Must be a valid callback function before this action is added
		 * @param [priority=10] Used to control when the function is executed in relation to other callbacks bound to the same hook
		 * @param [context] Supply a value to be used for this
		 */
		function addAction( action, callback, priority, context ) {
			if( typeof action === 'string' && typeof callback === 'function' ) {
				priority = parseInt( ( priority || 10 ), 10 );
				_addHook( 'actions', action, callback, priority, context );
			}

			return MethodsAvailable;
		}

		/**
		 * Performs an action if it exists. You can pass as many arguments as you want to this function; the only rule is
		 * that the first argument must always be the action.
		 */
		function doAction( /* action, arg1, arg2, ... */ ) {
			var args = slice.call( arguments );
			var action = args.shift();

			if( typeof action === 'string' ) {
				_runHook( 'actions', action, args );
			}

			return MethodsAvailable;
		}

		/**
		 * Removes the specified action if it contains a namespace.identifier & exists.
		 *
		 * @param action The action to remove
		 * @param [callback] Callback function to remove
		 */
		function removeAction( action, callback ) {
			if( typeof action === 'string' ) {
				_removeHook( 'actions', action, callback );
			}

			return MethodsAvailable;
		}

		/**
		 * Adds a filter to the event manager.
		 *
		 * @param filter Must contain namespace.identifier
		 * @param callback Must be a valid callback function before this action is added
		 * @param [priority=10] Used to control when the function is executed in relation to other callbacks bound to the same hook
		 * @param [context] Supply a value to be used for this
		 */
		function addFilter( filter, callback, priority, context ) {
			if( typeof filter === 'string' && typeof callback === 'function' ) {
				priority = parseInt( ( priority || 10 ), 10 );
				_addHook( 'filters', filter, callback, priority, context );
			}

			return MethodsAvailable;
		}

		/**
		 * Performs a filter if it exists. You should only ever pass 1 argument to be filtered. The only rule is that
		 * the first argument must always be the filter.
		 */
		function applyFilters( /* filter, filtered arg, arg2, ... */ ) {
			var args = slice.call( arguments );
			var filter = args.shift();

			if( typeof filter === 'string' ) {
				return _runHook( 'filters', filter, args );
			}

			return MethodsAvailable;
		}

		/**
		 * Removes the specified filter if it contains a namespace.identifier & exists.
		 *
		 * @param filter The action to remove
		 * @param [callback] Callback function to remove
		 */
		function removeFilter( filter, callback ) {
			if( typeof filter === 'string') {
				_removeHook( 'filters', filter, callback );
			}

			return MethodsAvailable;
		}

		/**
		 * Removes the specified hook by resetting the value of it.
		 *
		 * @param type Type of hook, either 'actions' or 'filters'
		 * @param hook The hook (namespace.identifier) to remove
		 * @private
		 */
		function _removeHook( type, hook, callback, context ) {
			var handlers, handler, i;
			
			if ( !STORAGE[ type ][ hook ] ) {
				return;
			}
			if ( !callback ) {
				STORAGE[ type ][ hook ] = [];
			} else {
				handlers = STORAGE[ type ][ hook ];
				if ( !context ) {
					for ( i = handlers.length; i--; ) {
						if ( handlers[i].callback === callback ) {
							handlers.splice( i, 1 );
						}
					}
				}
				else {
					for ( i = handlers.length; i--; ) {
						handler = handlers[i];
						if ( handler.callback === callback && handler.context === context) {
							handlers.splice( i, 1 );
						}
					}
				}
			}
		}

		/**
		 * Adds the hook to the appropriate storage container
		 *
		 * @param type 'actions' or 'filters'
		 * @param hook The hook (namespace.identifier) to add to our event manager
		 * @param callback The function that will be called when the hook is executed.
		 * @param priority The priority of this hook. Must be an integer.
		 * @param [context] A value to be used for this
		 * @private
		 */
		function _addHook( type, hook, callback, priority, context ) {
			var hookObject = {
				callback : callback,
				priority : priority,
				context : context
			};

			// Utilize 'prop itself' : http://jsperf.com/hasownproperty-vs-in-vs-undefined/19
			var hooks = STORAGE[ type ][ hook ];
			if( hooks ) {
				hooks.push( hookObject );
				hooks = _hookInsertSort( hooks );
			}
			else {
				hooks = [ hookObject ];
			}

			STORAGE[ type ][ hook ] = hooks;
		}

		/**
		 * Use an insert sort for keeping our hooks organized based on priority. This function is ridiculously faster
		 * than bubble sort, etc: http://jsperf.com/javascript-sort
		 *
		 * @param hooks The custom array containing all of the appropriate hooks to perform an insert sort on.
		 * @private
		 */
		function _hookInsertSort( hooks ) {
			var tmpHook, j, prevHook;
			for( var i = 1, len = hooks.length; i < len; i++ ) {
				tmpHook = hooks[ i ];
				j = i;
				while( ( prevHook = hooks[ j - 1 ] ) &&  prevHook.priority > tmpHook.priority ) {
					hooks[ j ] = hooks[ j - 1 ];
					--j;
				}
				hooks[ j ] = tmpHook;
			}

			return hooks;
		}

		/**
		 * Runs the specified hook. If it is an action, the value is not modified but if it is a filter, it is.
		 *
		 * @param type 'actions' or 'filters'
		 * @param hook The hook ( namespace.identifier ) to be ran.
		 * @param args Arguments to pass to the action/filter. If it's a filter, args is actually a single parameter.
		 * @private
		 */
		function _runHook( type, hook, args ) {
			var handlers = STORAGE[ type ][ hook ], i, len;
			
			if ( !handlers ) {
				return (type === 'filters') ? args[0] : false;
			}

			len = handlers.length;
			if ( type === 'filters' ) {
				for ( i = 0; i < len; i++ ) {
					args[ 0 ] = handlers[ i ].callback.apply( handlers[ i ].context, args );
				}
			} else {
				for ( i = 0; i < len; i++ ) {
					handlers[ i ].callback.apply( handlers[ i ].context, args );
				}
			}

			return ( type === 'filters' ) ? args[ 0 ] : true;
		}

		// return all of the publicly available methods
		return MethodsAvailable;

	};
	
	window.wp = window.wp || {};
	window.wp.hooks = new EventManager();

} )( window );

/*
 Tipr 2.0
 Copyright (c) 2015 Tipue
 Tipr is released under the MIT License
 http://www.tipue.com/tipr
 */


(function ( $ ) {

	$.fn.tipr = function ( options ) {

		var set = $.extend( {

			'speed': 200,
			'mode': 'bottom'

		}, options );

		return this.each( function () {

			var tipr_cont = '.tipr_container_' + set.mode;

			$( this ).hover(
				function () {
					var d_m = set.mode;

					if ( $( this ).attr( 'data-mode' ) ) {
						d_m = $( this ).attr( 'data-mode' )
						tipr_cont = '.tipr_container_' + d_m;
					}

					var out = '<div class="tipr_container_' + d_m + '"><div class="tipr_point_' + d_m + '"><div class="tipr_content">' + $( this ).attr( 'data-tip' ) + '</div></div></div>';

					$( this ).append( out );

					var w_t = $( tipr_cont ).outerWidth();
					var w_e = $( this ).width();
					var m_l = (w_e / 2) - (w_t / 2);

					$( tipr_cont ).css( 'margin-left', m_l + 'px' );
					$( this ).removeAttr( 'title alt' );

					if ( d_m == 'bottom' ) {
						$( tipr_cont ).css( 'margin-top', ( $( this ).outerHeight() / 2 ) + 'px' );
					}

					$( tipr_cont ).fadeIn( set.speed );
				},
				function () {
					$( tipr_cont ).remove();
				}
			);

		} );
	};

})( jQuery );
/**
 * Defines Project Huddle namespace
 * @since 1.0
 */

// strict mode
'use strict';

window.wp = window.wp || {};

// global namespace
var Huddle = window.Huddle = {

    apiURL: ph.api_url + 'projecthuddle/v1/',

	start: function ( data ) {
		this.setGlobals( data );

        // start router
        if ( !Huddle.router ) {
            Huddle.router = new Huddle.ProjectRouter();
        }

        // create project view
        Huddle.container = new Huddle.ProjectHuddleView({
            model: new Huddle.Project(data)
        });
        Huddle.container.inject('.project-huddle');

		// start history
		if ( !Backbone.History.started ) {
			Backbone.history.start();
		}

		// remove top bar on chrome
        window.scrollTo(0,1);

		// broadcast init
		wp.hooks.doAction( 'Huddle.start', this );
	},

	setGlobals: function ( data ) {
        // global body and window
        Huddle.body = jQuery('body');
        Huddle.window = jQuery(window);

		// set global project id variable
		Huddle.projectID = data ? data.project_id : false;

		// set global site url variable
		Huddle.siteURL = data ? data.site_url : false;

		// store global permalink variable
		Huddle.baseURL = data ? data.permalink : false;

		// get options
		Huddle.options = data ? data.options : false;

		// get translations
		Huddle.translations = data ? data.translations : false;

        Huddle.editorFormats = ['bold', 'italic', 'blockquote', 'code-block', 'link', 'list', 'code', 'image'];
        Huddle.editorOptions = ['bold', 'italic', 'blockquote', 'code-block', 'link', { 'list': 'ordered'}, { 'list': 'bullet' }];

		// global state model
		Huddle.state = new Huddle.State();

		// create user model
		Huddle.user = data ? new Huddle.User( data.user ) : new Huddle.User();

		// create new parent view for dialogs
		Huddle.dialog = new Huddle.DialogView();

		// create image collection model
		Huddle.images = data ? new Huddle.ImageCollection( data.images ) : new Huddle.ImageCollection();

		// set convenience permissions
		Huddle.permissions = new Huddle.Permissions();
	},

	currentImageHash: function() {
        Huddle.images.get(Huddle.state.get('image')).get('hash');
	},

    setLinkPlaceholder: function (quill) {
        var input          = quill.theme.tooltip.root.querySelector("input[data-link]");
        input.dataset.link = 'http://';
    },

    isWhitespace: function (ch) {
        var whiteSpace = false;
        if ((ch == ' ') || (ch == '\t') || (ch == '\n')) {
            whiteSpace = true;
        }
        return whiteSpace;
    },

    // Autolink URLs when typing or pasting
    autoLinkHighlight: function(quill) {
        quill.on('text-change', _.bind( function(delta, oldDelta, source) {
            var regex = /https?:\/\/[^\s]+$/;
            if(delta.ops.length === 2 && delta.ops[0].retain && this.isWhitespace(delta.ops[1].insert)) {
                var endRetain = delta.ops[0].retain;
                var text = quill.getText().substr(0, endRetain);
                var match = text.match(regex);

                if(match !== null) {
                    var url = match[0];

                    var ops = [];
                    if(endRetain > url.length) {
                        ops.push({ retain: endRetain - url.length });
                    }

                    ops = ops.concat([
                        { delete: url.length },
                        { insert: url, attributes: { link: url } }
                    ]);

                    quill.updateContents({
                        ops: ops
                    });
                }
            }
        }, this ));

        quill.clipboard.addMatcher(Node.TEXT_NODE, function(node, delta) {
            var regex = /https?:\/\/[^\s]+/g;
            if(typeof(node.data) !== 'string') return;
            var matches = node.data.match(regex);

            if(matches && matches.length > 0) {
                var ops = [];
                var str = node.data;
                matches.forEach(function(match) {
                    var split = str.split(match);
                    var beforeLink = split.shift();
                    ops.push({ insert: beforeLink });
                    ops.push({ insert: match, attributes: { link: match } });
                    str = split.join(match);
                });
                ops.push({ insert: str });
                delta.ops = ops;
            }

            return delta;
        });
	},

    /**
     * The MIT License (MIT)

     Copyright (c) 2016 Ryan Quinn

     Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

     The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

     THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

     * @param email
     * @param options
     * @returns {string}
     */
    gravatar: function(email, options) {
        // using md5() from here: http://www.myersdaily.org/joseph/javascript/md5-text.html
        function md5cycle(e,t){var n=e[0],r=e[1],i=e[2],s=e[3];n=ff(n,r,i,s,t[0],7,-680876936);s=ff(s,n,r,i,t[1],12,-389564586);i=ff(i,s,n,r,t[2],17,606105819);r=ff(r,i,s,n,t[3],22,-1044525330);n=ff(n,r,i,s,t[4],7,-176418897);s=ff(s,n,r,i,t[5],12,1200080426);i=ff(i,s,n,r,t[6],17,-1473231341);r=ff(r,i,s,n,t[7],22,-45705983);n=ff(n,r,i,s,t[8],7,1770035416);s=ff(s,n,r,i,t[9],12,-1958414417);i=ff(i,s,n,r,t[10],17,-42063);r=ff(r,i,s,n,t[11],22,-1990404162);n=ff(n,r,i,s,t[12],7,1804603682);s=ff(s,n,r,i,t[13],12,-40341101);i=ff(i,s,n,r,t[14],17,-1502002290);r=ff(r,i,s,n,t[15],22,1236535329);n=gg(n,r,i,s,t[1],5,-165796510);s=gg(s,n,r,i,t[6],9,-1069501632);i=gg(i,s,n,r,t[11],14,643717713);r=gg(r,i,s,n,t[0],20,-373897302);n=gg(n,r,i,s,t[5],5,-701558691);s=gg(s,n,r,i,t[10],9,38016083);i=gg(i,s,n,r,t[15],14,-660478335);r=gg(r,i,s,n,t[4],20,-405537848);n=gg(n,r,i,s,t[9],5,568446438);s=gg(s,n,r,i,t[14],9,-1019803690);i=gg(i,s,n,r,t[3],14,-187363961);r=gg(r,i,s,n,t[8],20,1163531501);n=gg(n,r,i,s,t[13],5,-1444681467);s=gg(s,n,r,i,t[2],9,-51403784);i=gg(i,s,n,r,t[7],14,1735328473);r=gg(r,i,s,n,t[12],20,-1926607734);n=hh(n,r,i,s,t[5],4,-378558);s=hh(s,n,r,i,t[8],11,-2022574463);i=hh(i,s,n,r,t[11],16,1839030562);r=hh(r,i,s,n,t[14],23,-35309556);n=hh(n,r,i,s,t[1],4,-1530992060);s=hh(s,n,r,i,t[4],11,1272893353);i=hh(i,s,n,r,t[7],16,-155497632);r=hh(r,i,s,n,t[10],23,-1094730640);n=hh(n,r,i,s,t[13],4,681279174);s=hh(s,n,r,i,t[0],11,-358537222);i=hh(i,s,n,r,t[3],16,-722521979);r=hh(r,i,s,n,t[6],23,76029189);n=hh(n,r,i,s,t[9],4,-640364487);s=hh(s,n,r,i,t[12],11,-421815835);i=hh(i,s,n,r,t[15],16,530742520);r=hh(r,i,s,n,t[2],23,-995338651);n=ii(n,r,i,s,t[0],6,-198630844);s=ii(s,n,r,i,t[7],10,1126891415);i=ii(i,s,n,r,t[14],15,-1416354905);r=ii(r,i,s,n,t[5],21,-57434055);n=ii(n,r,i,s,t[12],6,1700485571);s=ii(s,n,r,i,t[3],10,-1894986606);i=ii(i,s,n,r,t[10],15,-1051523);r=ii(r,i,s,n,t[1],21,-2054922799);n=ii(n,r,i,s,t[8],6,1873313359);s=ii(s,n,r,i,t[15],10,-30611744);i=ii(i,s,n,r,t[6],15,-1560198380);r=ii(r,i,s,n,t[13],21,1309151649);n=ii(n,r,i,s,t[4],6,-145523070);s=ii(s,n,r,i,t[11],10,-1120210379);i=ii(i,s,n,r,t[2],15,718787259);r=ii(r,i,s,n,t[9],21,-343485551);e[0]=add32(n,e[0]);e[1]=add32(r,e[1]);e[2]=add32(i,e[2]);e[3]=add32(s,e[3])}function cmn(e,t,n,r,i,s){t=add32(add32(t,e),add32(r,s));return add32(t<<i|t>>>32-i,n)}function ff(e,t,n,r,i,s,o){return cmn(t&n|~t&r,e,t,i,s,o)}function gg(e,t,n,r,i,s,o){return cmn(t&r|n&~r,e,t,i,s,o)}function hh(e,t,n,r,i,s,o){return cmn(t^n^r,e,t,i,s,o)}function ii(e,t,n,r,i,s,o){return cmn(n^(t|~r),e,t,i,s,o)}function md51(e){var txt="";var t=e.length,n=[1732584193,-271733879,-1732584194,271733878],r;for(r=64;r<=e.length;r+=64){md5cycle(n,md5blk(e.substring(r-64,r)))}e=e.substring(r-64);var i=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];for(r=0;r<e.length;r++)i[r>>2]|=e.charCodeAt(r)<<(r%4<<3);i[r>>2]|=128<<(r%4<<3);if(r>55){md5cycle(n,i);for(r=0;r<16;r++)i[r]=0}i[14]=t*8;md5cycle(n,i);return n}function md5blk(e){var t=[],n;for(n=0;n<64;n+=4){t[n>>2]=e.charCodeAt(n)+(e.charCodeAt(n+1)<<8)+(e.charCodeAt(n+2)<<16)+(e.charCodeAt(n+3)<<24)}return t}function rhex(e){var t="",n=0;for(;n<4;n++)t+=hex_chr[e>>n*8+4&15]+hex_chr[e>>n*8&15];return t}function hex(e){for(var t=0;t<e.length;t++)e[t]=rhex(e[t]);return e.join("")}function md5(e){return hex(md51(e))}function add32(e,t){return e+t&4294967295}var hex_chr="0123456789abcdef".split("");if(md5("hello")!="5d41402abc4b2a76b9719d911017c592"){function add32(e,t){var n=(e&65535)+(t&65535),r=(e>>16)+(t>>16)+(n>>16);return r<<16|n&65535}}
        //check to make sure you gave us something
        var options = options || {},
            base,
            params = [];

        //set some defaults, just in case
        options = {
            size: options.size || "50",
            rating: options.rating || "g",
            secure: options.secure || (location.protocol === 'https:'),
            backup: options.backup || ""
        };

        //setup the email address
        email = email.trim().toLowerCase();

        //determine which base to use
        base = '//www.gravatar.com/avatar/';

        //add the params
        if (options.rating) {params.push("r=" + options.rating)};
        if (options.backup) {params.push("d=" + encodeURIComponent(options.backup))};
        if (options.size) {params.push("s=" + options.size)};

        //now throw it all together
        return base + md5(email) + "?" + params.join("&");
    }
};
/**
 * Mixins used in the app. Used to sync admin-ajax.php with backbone
 *
 * @package     ProjectHuddle
 * @subpackage  js
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0.0
 */

/**
 * A mixin for collections/models that syncs with admin-ajax.php
 *
 * @since 1.0.0
 */
var phSyncMixin = {
    // sync function
    sync: function (method, model, options) {
        options = options || {};
        options.beforeSend = function(xhr) {
            xhr.setRequestHeader('X-WP-Nonce', ph.nonce);
        };

        // toastr errors
        options.error = function (model, response, options) {
            if (typeof model.responseJSON != 'undefined' && typeof model.responseJSON.code != 'undefinted') {
                switch (model.responseJSON.code) {
                    case 'rest_cookie_invalid_nonce':
                        toastr.error(Huddle.translations.session_expired);
                        break;
                    default:
                        toastr.error(model.responseJSON.message);
                        break;
                }
            }
            console.error(response);
        };

        // pass project id, image id, user information every time
        model.set({
            'project_id': Huddle.projectID,
            'image_id': Huddle.state.get('image'),
            'user': Huddle.user
        }, {'silent': true});

        /**
         * Call Backbone sync method
         */
        return Backbone.sync.apply(this, arguments);
    }
};

/**
 * A model for all the syncable models to extend
 *
 * Adds toast errors if they exist
 *
 * @since 1.0.0
 */
var BaseModel = Backbone.Model.extend( _.defaults( {
	/**
	 * Show errors if there are any
	 *
	 * @param response {object} Ajax response
	 */
    parse: function ( response, options ) {
        // Show our errors
        if (  response.success == false ) {

            // log error
            console.error( response );

            // trigger WordPress error if it exists
            if ( typeof response.data == 'string' ) {
                toastr.error( response.data );
            }

            return false;

        } else {
            // trigger WordPress error if it exists
            if ( typeof response.data == 'string' ) {
                toastr.success( response.data );
            }
            return response;
        }
    },

	/**
	 * Makes for easier ajax functions and triggers
	 *
	 * @param model             {object}    Model to run function
	 * @param callback          {function}  Function to run
	 * @param trigger           {string}    Event to trigger on Success
	 * @param failObjectTrigger {string}    Event to trigger if failure is object
	 */
	doAction: function( model, callback, trigger, failObjectTrigger ) {
		model[callback]( undefined, {
			success: function ( model, response, options ) {
				// handle success
				if ( response.success != false ) {
					model.trigger( trigger, model );
                    // global event too
                    Huddle.Event && Huddle.Event.trigger(  trigger, model  );
				} else {
					// if response is new object
					if ( typeof response.data == 'object' ) {
						failObjectTrigger && model.trigger( failObjectTrigger, response.data );
					}
				}
			},
			error: function ( model, xhr, options ) {
				console.error( xhr ); // don't output error for user
				toastr.error( 'Something went wrong. Please try again.' );
			}
		} );
	}
}, phSyncMixin ) );

/**
 * A collection for all the syncable collections to extend
 *
 * @since 1.0.0
 */
var BaseCollection = Backbone.Collection.extend( _.defaults( {
	/**
	 * Show errors if there are any
	 *
	 * @param response {object} Ajax response
	 */
    parse: function ( response ) {
        // Show our errors
        if ( response.success == false ) {

            // log error
            console.error( response );

            // trigger WordPress error if it exists
            if ( typeof response.data == 'string' ) {
                toastr.error( response.data );
            }

            return false;

        } else {
            // trigger WordPress error if it exists
            if ( typeof response.data == 'string' ) {
                toastr.success( response.data );
            }
            return response;
        }
    },

    /**
     * Makes for easier ajax functions and triggers
     *
     * @param model             {object}    Model to run function
     * @param callback          {function}  Function to run
     * @param trigger           {string}    Event to trigger on Success
     * @param failObjectTrigger {string}    Event to trigger if failure is object
     */
    doAction: function( model, callback, trigger, failObjectTrigger ) {
        model[callback]( undefined, {
            success: function ( model, response, options ) {
                // handle success
                if ( response.success != false ) {
                    model.trigger( trigger, model );

                    // global event too
                    Huddle.Event && Huddle.Event.trigger(  trigger, model  );
                } else {
	                // if response is new object
	                if ( typeof response.data == 'object' ) {
		                failObjectTrigger && model.trigger( failObjectTrigger, response.data );
	                }
                }
            },
            error: function ( model, xhr, options ) {
                console.error( xhr ); // don't output error for user
                toastr.error( 'Something went wrong. Please try again.' );
            }
        } );
    }
}, phSyncMixin ) );

/**
 * A view for all wp views to extend
 *
 * Extends wp.Backbone.View with .prepare() and .inject()
 *
 * @since 1.0.0
 */
Huddle.View = wp.Backbone.View.extend({
	inject: function( selector ) {
        this.render();
        jQuery(selector).html( this.el );
        this.views.ready();
    },

    prepare: function() {
        if ( ! _.isUndefined( this.model ) && _.isFunction( this.model.toJSON ) ) {
	        this._parseTriggers();
            return this.model.toJSON();
        } else {
            return {};
        }
    },

    _parseTriggers: function () {
        if ( this.triggers ) {
            _.each( this.triggers || {}, function ( fn, event ) {

                // objects
                if ( typeof fn == 'object' ) {
                    _.each(fn, function (fn) {
                        var oHandler = this[fn];
                        if ( _.isFunction( oHandler ) ) {
                            this.stopListening( this.model, event, oHandler );
                            this.listenTo( this.model, event, oHandler );
                        }
                    }, this);
                    return false;
                }

                // regular
                var handler = this[fn];
                if ( _.isFunction( handler ) ) {
                    this.stopListening( this.model, event, handler );
                    this.listenTo( this.model, event, handler );
                }
            }, this );
        }
    }
});

/**
 * Underscore Mixins
 *
 * @since 1.0.0
 */
_.mixin( {
    /**
     * Convert /n newline to <br>
     *
     * @param str String to convert
     * @param is_xhtml Use xhtml tag
     * @returns {string} Output with <br> tag
     *
     * @since 1.0.0
     */
    nl2br: function ( str, is_xhtml ) {
        var breakTag = (is_xhtml || typeof is_xhtml === 'undefined') ? '<br />' : '<br>';
        return (str + '').replace( /([^>\r\n]?)(\r\n|\n\r|\r|\n)/g, '$1' + breakTag + '$2' );
    }
} );

_.mixin({
    capitalize: function(string) {
        return string.charAt(0).toUpperCase() + string.substring(1).toLowerCase();
    }
});
/**
 * Declare global events in namespace
 */
Huddle.Event = _.extend( {}, Backbone.Events );
/**
 * Model to store our individual comment item
 *
 * @since 1.0
 */
Huddle.CommentItem = BaseModel.extend({
    defaults: {
        id: null,
        user_id: '',
        comment_ID: false,
        comment_post_ID: false,
        comment_author: "Guest",
        comment_author_email: "",
        comment_content: "",
        comment_parent: 0,
        date: "Now",
        moderate: false,
        edit: false
    },

    urlRoot: Huddle.apiURL + 'mockup/comment',

    validate: function(attrs, options) {
        if (attrs.comment_content.length < 1 || attrs.comment_content == '<p><br></p>') {
            return Huddle.translations.no_comment_text;
        }
    },

    initialize: function () {
        wp.hooks.doAction('Huddle.CommentItem.initialize', this);
    }
});
/**
 * Model to store our individual parent comments with location
 *
 * @extends BaseModel Sync, save, fetch, update functions with app-ajax
 *
 * @since 1.0
 */
Huddle.Comment = BaseModel.extend({
    defaults: {
        id: null,
        title: 'Comment Thread',
        avatar: false,
        comment_count: 0,
        comment_content: '',
        comment_author: false,
        comment_author_email: false,
        newCommentText: false,
        imageID: false,
        new: false,
        order: 0,
        relativeX: 0,
        relativeY: 0,
        x: 0,
        y: 0,
        show: false,
        hover: false,
        focus: false,
        controls: false
    },

    urlRoot: Huddle.apiURL + 'mockup/comment-thread',

    // Store comment items collection in comment model
    items: {},

    initialize: function () {
        // when comment is initialized, create new comment item collection inside
        this.items = new Huddle.CommentItemCollection(this.get('items') || []);
        this.unset('items');

        this.updateComment();
        this.listenTo(this.items, 'add remove change', this.updateComment);

        this.listenTo(this, 'invalid', this.toast);

        // broadcast init
        wp.hooks.doAction('Huddle.Comment.initialize', this);
    },

    toast: function() {
        toastr.error(this.validationError);
    },

    /**
     * Make first comment the title
     */
    updateComment: function () {
        if (!this.items.length) return;

        // first comment
        var first = this.items.first();

        this.set({
            'comment_count': this.items.length,
            'title': first.get('comment_content'),
            'avatar': first.get('avatar'),
            'comment_author': first.get('comment_author'),
            'date': first.get('date')
        });
    }
});
/**
 * Model to store our individual images
 *
 * Handles and orchestrates all listeners for comments.
 *
 * @extends BaseModel Sync, save, fetch, update functions with admin-ajax
 *
 * @since 1.0
 */

Huddle.Image = BaseModel.extend({
    defaults: {
        id: null,
        comment_count: 0,
        thread_count: 0,
        showComments: false,
        date: "Now",
        hash: false,
        imageID: false,
        success: false,
        thumbnail: false,
        title: 'Image',
        url: false,
        zoom: '',
        magnification: 1,
        zoomAmount: 1.25,
        retina: false,
        hideComments: false,
        options: {
            alignment: 'center', // left or right
            size: 'normal', // normal or scale
            background_color: '#000', // hex value
            background_image: false, // background-image
            background_image_position: 'repeat' // center, repeat, repeat-x, cover
        }
    },

    urlRoot: Huddle.apiURL + 'mockup/image',

	// Store image comments collection in image model
    comments: {},

    /**
     * When an image model is initialized, store the comment collection
     */
    initialize: function () {
	    // create comments collection contained in this parent model
	    this.comments = new Huddle.CommentCollection( this.get( 'comments' ) || [] );
	    this.comments.parent_id = this.get('id');
	    this.unset( 'comments' );

        this.listenTo(this.comments, 'change add remove reset', this.updateCounts);
        this.listenTo(this.comments, 'change add remove reset', this.updateOrder);
        this.updateCounts();

        // set retina on/off
        if (Huddle.options && Huddle.options.project && Huddle.options.project.retina_images) {
            this.set('retina', Huddle.options.project.retina_images);
        }

        this.listenTo(this, 'change:zoom', this.magnify);

        // broadcast init
        wp.hooks.doAction('Huddle.Image.initialize', this);
    },

    // set magnification when zoom occurs
    magnify: function () {
        if (this.get('zoom') === 'in') {
            this.set('magnification', this.get('magnification') * this.get('zoomAmount'));
        } else {
            this.set('magnification', this.get('magnification') / this.get('zoomAmount'));
        }
    },

    /**
     * Update published thread count in image model
     */
    updateCounts: function () {
        this.updateThreadCount();
        this.updateTotalCommentCount();
    },

    /**
     * Update number of threads on image
     */
    updateThreadCount: function() {
        this.set({
            thread_count: this.comments.filter(function (comment) {
                return !comment.isNew();
            }).length
        });
    },

    /**
     * Update total comments on image
     */
    updateTotalCommentCount: function() {
        var comment_count = 0;
        _.each(this.comments.models, function (comment) {
            comment_count = comment_count + comment.items.length;
        }, this);
        this.set({'comment_count': comment_count});
    },

    /**
     * Silently set the order attribute of a single comment
     *
     * @param comment {object} Comment object
     */
    setOrder: function (comment) {
        comment.set({
            order: this.comments.indexOf(comment)
        }, {
            silent: true
        });
    },

    /**
     * Update the order attribute for all comments
     *
     * @param model {object} Model
     * @param options {object} Options
     * @param silent {bool} Set silently or not
     */
    updateOrder: function (model, options, silent) {
        _.each(this.comments.models, function (comment) {
            comment.set({
                order: this.comments.indexOf(comment)
            }, {
                silent: typeof silent == 'boolean' && silent ? silent : false
            });
        }, this);
    }
});
/**
 * Model to store our front end permissions
 *
 * This is only for convenience. Actual permissions are validated on the server.
 *
 * @extends BaseModel Sync, save, fetch, update functions with app-ajax
 *
 * @since 1.0
 */
Huddle.Permissions = BaseModel.extend({
    defaults: {
        moderate: false,
        allowComments: false,
        loggedIn: false
    },

    initialize: function () {
        // set on init
        this.setPermissions();

        // set after identify success
        this.listenTo(Huddle.Event, 'identifySuccess', this.setPermissions);

        // broadcast init
        wp.hooks.doAction('Huddle.Permissions.initialize', this);
    },

    /**
     * Set permissions model values
     */
    setPermissions: function () {
        this.loggedIn();
        this.moderateComments();
        this.allowComments();
    },

    /**
     * If user is logged in
     */
    loggedIn: function () {
        this.set('loggedIn', Huddle.user.get('logged_in'));
    },

    /**
     * User can moderate comments
     */
    moderateComments: function () {
        var caps = Huddle.user.get('capabilities');
        if ( caps['moderate_ph-project_comments'] !== undefined ) {
            this.set('moderate', caps['moderate_ph-project_comments']);
        } else {
            this.set('moderate', false);
        }
    },

    /**
     * If comments are allowed
     */
    allowComments: function () {
        if (Huddle.options.project.allow_anon_comments == 'on' || Huddle.user.get('logged_in')) {
            this.set({
                'allowComments': true
            });
        }
    }
});
/**
 * Model to store our Project
 *
 * Handles and orchestrates all listeners for comments.
 *
 * @extends BaseModel Sync, save, fetch, update functions with admin-ajax
 *
 * @since 1.0
 */
Huddle.Project = BaseModel.extend({
    defaults: {
        id: null,
        approved: false,
        name: 'the entire project',
        options: {},
        permalink: '',
        filter: 'all',
        mobileMenu: false,
        project_id: 0,
        showPanel: false,
        site_url: false,
        translations: {},
        user: {},
        imageCount: 0
    },

    urlRoot: Huddle.apiURL + 'mockup',

    // Store image comments collection in image model
    images: {},

    /**
     * When an image model is initialized, store the comment collection
     */
    initialize: function () {
        // create comments collection contained in this parent model
        this.images = new Huddle.ImageCollection(this.get('images') || []);
        this.unset('images');

        this.listenTo(this.images, 'change', this.count);
        this.count();
    },

    count: function() {
        this.set('imageCount', this.images.length);
    }
});
/**
 * Model to store current author info
 *
 * @extends BaseModel Sync, save, fetch, update functions with app-ajax
 *
 * @since 1.0
 */

Huddle.State = BaseModel.extend({
    defaults: {
        'comment': null,
        'image': false,
        'tray': false,
        'commentText': false,
        'x': false,
        'y': false,
        'panel': false
    },

    /**
     * When image state is changed, silently clear other attributes
     */
    initialize: function () {
        // broadcast init
        wp.hooks.doAction('Huddle.State.initialize', this);
    }
});

/**
 * Model to store current author info
 *
 * @since 1.0
 */
Huddle.User = BaseModel.extend({
    defaults: {
        id           : null,
        user_email   : '',
        display_name : 'Guest',
        user_nicename: 'Guest',
        username     : '',
        password     : '',
        ID           : 0,
        avatar       : ''
    },

    // sync function
    sync: function (method, model, options) {
        options            = options || {};
        options.beforeSend = function (xhr) {
            xhr.setRequestHeader('X-WP-Nonce', ph.nonce);
        };

        // toastr errors
        options.error = function (model, response, options) {
            switch (model.responseJSON.code) {
                case 'rest_cookie_invalid_nonce':
                    toastr.error(Huddle.translations.session_expired);
                    break;
                default:
                    toastr.error(model.responseJSON.message);
                    break;
            }
            console.error(model);
            console.error(model.responseJSON);
        };

        // pass project id, image id, user information every time
        model.set({
            'project_id': Huddle.projectID,
            'image_id'  : Huddle.state.get('image')
        }, {'silent': true});

        return Backbone.sync.apply(this, arguments);
    },

    urlRoot: Huddle.apiURL + 'user',

    initialize: function () {
        this.setUser();

        this.listenTo(this, 'change', this.avatar);
        this.avatar();

        // broadcast init
        wp.hooks.doAction('Huddle.User.initialize', this);
    },

    // set user from cookies if not logged in
    setUser: function() {
        if (!this.get('ID') && Cookies.get('Huddle.user')) {
            this.set(Cookies.getJSON('Huddle.user'));
        }
    },

    forget: function() {
        this.clear().set(this.defaults);
        Cookies.remove('Huddle.user');
    },

    avatar: function() {
        if ( this.get('user_email') ) {
            this.set('avatar', '<img src="' + Huddle.gravatar(this.get('user_email'), {
                size: 64,
                rating: 'r',
                backup: Huddle.options.global.avatar_default
            }) + '"/>');
        }
    }
});
/**
 * Collection to store all comments for an image
 *
 * @extends BaseCollection Sync, save, fetch, update functions with app-ajax
 *
 * @since 1.0
 */
Huddle.CommentCollection = BaseCollection.extend( {

	// Use comment item for model in the collection
	model: Huddle.Comment,

	initialize: function () {
		// when added to the collection, save it automatically
		this.listenTo( this, 'newCommentLocation', this.saveLocation );

		// when comment is removed, move it to the trash
		this.listenTo( this, 'trashLocation', this.removeLocation );

		// when event is triggered, updateComment
		this.listenTo( this, "locationChanged", this.updateLocationMeta );

		// when comment is shared, email
		this.listenTo( this, 'shareComment', this.shareComment );

		// when the order is changed in a comment, save it
		this.listenTo( this, 'change:order', this.updateOrder );

		// when the location is removed, remove the model from the collection
		this.listenTo( this, 'locationRemoved', this.removeComment );

		// broadcast init
		wp.hooks.doAction( 'Huddle.CommentCollection.initialize', this );
	}
} );
/**
 * Collection to store all comments for an image
 *
 * @extends BaseCollection Sync, save, fetch, update functions with app-ajax
 *
 * @since 1.0
 */
Huddle.CommentItemCollection = BaseCollection.extend({
    model: Huddle.CommentItem,

    initialize: function () {
        // broadcast init
        wp.hooks.doAction('Huddle.CommentItemCollection.initialize', this);
    }
});
/**
 * Collection to store all the images for this post
 *
 * @extends BaseCollection Sync, save, fetch, update functions with app-ajax
 *
 * @since 1.0
 */
Huddle.ImageCollection = BaseCollection.extend({

    // Use image model for this collection
    model: Huddle.Image,

	initialize: function() {
		// image request to be shared, share image
		this.listenTo( this, 'shareImage', this.shareImage );

		// broadcast init
		wp.hooks.doAction( 'Huddle.ImageCollection.initialize', this );
	},

	/**
	 * Shares an image via email
	 *
	 * @param image model to share
	 */
	shareImage: function ( image ) {
		this.doAction( image, 'share', 'emailSuccess' );
	}
} );
/**
 * View to show our comment button
 *
 * @since 1.0
 */
Huddle.CommentCancelButtonView = Huddle.View.extend({
    template: wp.template('ph-comment-cancel-button'),
    className: 'ph-cancel',
    tagName: 'span',

    events: {
        'click': 'cancelComment'
    },

    cancelComment: function () {
        if (!this.model.get('comment_content')) {
            this.model.set('controls', false);
            this.model.isNew() && this.model.destroy();
            return;
        }

        vex.dialog.confirm({
            message: Huddle.translations.discard ? Huddle.translations.discard : 'Are you sure you want to discard this comment without saving?',
            callback: _.bind(function (value) {
                if (value) {
                    if (this.model.isNew()) {
                        this.model.destroy();
                    } else {
                        this.model.trigger('resetTextArea');
                        this.model.set('comment_content', '');
                    }
                    this.model.set('controls', false);
                }
            }, this)
        });
        return false;
    }
});
/**
 * View to show our individual comment item edit box
 *
 * @since 1.0
 */
Huddle.CommentEditFormView = Huddle.View.extend({
    template: wp.template('edit-comment-form'),
    className: 'ph-edit-form',

    events: {
        'click .ph-edit-cancel': 'cancelEdit',
        'click .ph-edit-save:enabled': 'updateComment'
    },

    initialize: function() {
        this.listenTo(this.model, 'change:edit', this.toggleEdit);
        this.listenTo(this.model, 'change:edit', this.setQuill);
    },

    ready: function() {
      this.toggleEdit();
    },

    setQuill: function() {
        if (!this.quill) {
            this.quill = new Quill(this.$('.ph-edit-content').get(0), {
                modules: {toolbar: Huddle.editorOptions},
                formats: Huddle.editorFormats,
                theme: 'bubble',
                bounds: this.el
            });
            Huddle.autoLinkHighlight(this.quill);
            Huddle.setLinkPlaceholder(this.quill);
        }
    },

    toggleEdit: function() {
        this.$el.toggle(this.model.get('edit'));
    },

    cancelEdit: function() {
        this.model.set('edit', false);
    },

    updateComment: function() {
        this.model.save({
            'comment_content': this.$('.ql-editor').html(),
            'edit': false // done editing
        });
        return false;
    }
});
/**
 * View to show our comment form
 *
 * @since 1.0
 */
Huddle.CommentFormView = Huddle.View.extend({
    className: 'comment-textarea',
    tagName: 'div',

    events: {
        "keydown .ql-editor": "keyDownHandler",
        "focus .ql-editor": "textAreaFocus"
    },

    /**
     * Model trigger handlers
     */
    triggers: {
        'disableTextArea': 'disableTextArea',
        'resetTextArea': 'resetTextArea',
        'focusTextArea': [
            'enableTextArea',
            'resetTextArea',
            'focusTextArea'
        ],
        'enableTextArea': 'enableTextArea',
        'change:controls': 'focusClass',
        'change:focus': 'focusHandler'
    },

    initialize: function() {
        this.listenTo(this.model.items, 'add', this.resetTextArea);
    },

	ready: function() {
        this.setQuill();
        this.focusHandler();
	},

    focusHandler: function() {
        this.model.get('focus') && this.focusTextArea();
    },

	setQuill: function() {
        this.quill = new Quill(this.$el.html('<div class="comment-container-inner"></div>').get(0), {
            modules: { toolbar: Huddle.editorOptions },
            formats: Huddle.editorFormats,
            bounds: this.el,
            placeholder: Huddle.translations && Huddle.translations.comment_placeholder
                ? Huddle.translations.comment_placeholder
                : 'Leave a comment',
            theme: 'bubble'
        });

        Huddle.autoLinkHighlight(this.quill);
        Huddle.setLinkPlaceholder(this.quill);

        // on text-change
        this.quill.on('text-change', _.bind(this.contentChangedHandler, this));
	},

    textAreaFocus: function() {
        this.model.set('controls', true);
    },

    focusClass: function() {
        this.$el.toggleClass('focus', this.model.get('controls'));
    },

    disableTextArea: function () {
        this.quill.disable();
    },

    enableTextArea: function () {
        this.quill.enable();
    },

    focusTextArea: function () {
        _.defer(_.bind(function() { this.quill.focus(); }, this));
    },

    resetTextArea: function() {
        this.quill.setContents([{insert: '\n'}]);
        this.$('.ql-tooltip').addClass('.ql-hidden');
    },

    contentChangedHandler: function (delta, oldDelta, source) {
        this.model.set('comment_content', this.$('.ql-editor').html());
    },

    /**
     * Detects control + enter to submit comment
     * @param e Event
     */
    keyDownHandler: function (e) {
        if (!(e.keyCode == 13 && e.metaKey)) return;
        e.preventDefault();
        this.model.trigger('submitComment');
    },

    destroy: function() {
        this.quill.off('text-change');
	}
});

/**
 * View to show our comment form
 *
 * @since 1.0
 */
Huddle.CommentHeaderView = Huddle.View.extend({

    template: wp.template('project-comment-header'),
    className: 'ph-header-inner',

    events: {
        'click .ph-share-comment': 'triggerCommentShare',
        'click .ph-copy-link': 'triggerCopyLink',
        'click .ph-delete-comment-location': 'deleteLocation'
    },

    // broadcast init
    initialize: function () {
        wp.hooks.doAction('Huddle.CommentHeaderView.initialize', this);
    },

    /**
     * Checks if it's a new comment
     * @returns {boolean} True if it's a new comment
     */
    newComment: function () {
        if (this.model.isNew()) {
            toastr.error(Huddle.translations.save_comment_first);
            return true;
        }
        return false;
    },

    /**
     * Trigger copy comment link
     * @param e Event
     */
    triggerCopyLink: function (e) {
        e.preventDefault();

        // bail if comment hasn't been saved yet
        if (this.newComment()) {
            return false;
        }

        // trigger event
        Huddle.Event.trigger('copyCommentLink', this.model);
    },

    /**
     * Trigger share comment
     * @param e Event
     */
    triggerCommentShare: function (e) {
        e.preventDefault();

        // bail if comment hasn't been saved yet
        if (this.model.isNew()) {
            return false;
        }

        // trigger event
        Huddle.Event.trigger('shareComment', this.model);
    },

    /**
     * Trigger delete comment location
     * @param e Event
     */
    deleteLocation: function (e) {
        vex.dialog.confirm({
            message: jQuery(e.currentTarget).data('confirm'),
            callback: _.bind(function (value) {
                if (value == false) return false;
                this.model.destroy();
            }, this)
        });

        return false;
    }

});

/**
 * View to show our comment form
 *
 * @since 1.0
 */
Huddle.CommentInfoView = Huddle.View.extend( {

	className: 'ph-comment-info-inner',

	triggers: {
		'hideMessage': 'hideMessage'
	},

	initialize: function() {
		this.listenTo( this.model.items, 'reRender', this.showChangedMessage );

		// broadcast init
		wp.hooks.doAction( 'Huddle.CommentInfoView.initialize', this );
	},

	/**
	 * Trigger message if comments changed
	 */
	showChangedMessage: function () {
		this.showMessage( Huddle.translations.comments_changed, 'warning' );
	},

	/**
	 * Hides the message
	 */
	hideMessage: function () {
		this.$el.parent( '.ph-comment-info' ).stop( true ).slideUp( 500 );
	},

	/**
	 * Shows the message
	 *
	 * @param comment {string} Comment Text
	 * @param type {string} Class to add to parent container
	 */
	showMessage: function ( comment, type ) {
		this.$el.html( comment );

		this.$el.parent( '.ph-comment-info' )
			.addClass( type )
			.stop( true )
			.slideDown( 500 );
	}

} );

/**
 * View to show our individual comment item text
 *
 * @since 1.0
 */
Huddle.CommentItemControlsView = Huddle.View.extend({
    template: wp.template('comment-item-controls'),
    className: 'comment-item-controls-inner',

    initialize: function() {
        this.listenTo(this.model, 'change:edit', this.showHide);
    },

    showHide: function() {
        this.$el.toggle(!this.model.get('edit'));
    }
});
/**
 * View to show our individual comment item text
 *
 * @since 1.0
 */
Huddle.CommentItemTextView = Huddle.View.extend({
    template: wp.template('comment-item-text'),
    className: 'comment-item-text',

    initialize: function() {
        this.listenTo(this.model, 'change:edit', this.showHide);
        this.listenTo(this.model, 'request', this.render);
    },

    showHide: function() {
        this.$el.toggle(!this.model.get('edit'));
    }
});
/**
 * View to show our individual comment item
 *
 * @since 1.0
 */
Huddle.CommentItemView = Huddle.View.extend({
    template: wp.template('project-comment-item'),
    className: 'ph-comment-item',

    events: {
        'click .ph-remove': 'removeComment',
        'click .ph-edit': 'editComment'
    },

    initialize: function () {
        // check vanity permissions
        this.moderation();

        // comment item text view
        this.views.set('.ph-comment-item-text', new Huddle.CommentItemTextView({
            model: this.model
        }));

        // edit comment form
        this.views.set('.ph-edit-textarea', new Huddle.CommentEditFormView({
            model: this.model
        }));

        // comment item text view
        this.model.get('moderate') && this.views.set('.ph-item-controls', new Huddle.CommentItemControlsView({
            model: this.model
        }));

        // broadcast init
        wp.hooks.doAction('Huddle.CommentItemView.initialize', this);
    },

    /**
     * Checks if user can moderate the post
     *
     * For front end convenience only
     */
    moderation: function () {
        this.model.set({
            'moderate': Huddle.permissions.get('moderate') ? Huddle.permissions.get('moderate') : false
        });

        // if logged in and email matches comment_author_email
        if (Huddle.user.get('user_email') == this.model.get('comment_author_email')) {
            // make sure comment isn't from a logged in user
            this.model.set('moderate', true);
        }
    },

    /**
     * Remove comment click handler - let the collection handle itself
     */
    removeComment: function (e) {
        vex.dialog.confirm({
            message: jQuery(e.currentTarget).data('confirm'),
            callback: _.bind(function (value) {
                if (value == false) {
                    return false;
                }
                this.destroyComment();
            }, this)
        });
        return false;
    },

    /**
     * Shows the edit textbox, focuses and places cursor at end
     */
    editComment: function () {
        this.model.set('edit', true);
    },

    /**
     * Animate removal
     */
    destroyComment: function () {
        this.$el.slideToggle(250, _.bind(function () {
            this.remove();
            this.unbind();
            this.model.destroy();
        }, this));
    }
});
/**
 * Comment Panel View
 */
Huddle.CommentsPanelView = Huddle.View.extend( {
    id: 'ph-comments-panel',
    template: wp.template( 'comments-panel' ),

    events: {
      'click .close-panel': 'close'
    },

    initialize: function() {
        this.listenTo(Huddle.state, 'change:panel', this.openClose);
        this.listenTo(Huddle.state, 'change:image', this.setComments);
    },

    ready: function() {
        this.topBar = jQuery('#top-bar');
        this.$el.css('top', this.topBar.outerHeight());
        this.topBar.find('img').load(_.bind(function() {
            this.$el.css('top', this.topBar.outerHeight());
        }, this ));
    },

    /**
     * Show/Hide panel
     * @param state
     */
    openClose: function (state) {
        this.$el.toggleClass('ph-show', state.get('panel'));
    },

    /**
     * Close panel using state
     */
    close: function() {
       Huddle.state.set('panel', false);
       return false;
    },

    /**
     * Add comment views
     * @param state
     */
    setComments: function (state) {
        this.views.set('.ph-comments-container', new Huddle.CommentsListContainerView({
            model: this.model.images.get(state.get('image'))
        }));
    }
});

/**
 * Comments List Container
 */
Huddle.CommentsListContainerView = Huddle.View.extend({
    id: 'ph-comments-list-container',

    initialize: function(){
        this.listenTo(this.model, 'change', this.setComments);
        this.setComments();
    },
    setComments: function() {
        this.views.set(new Huddle.CommentsListView({
            model: this.model
        }));
    }
});

Huddle.CommentsListView = Huddle.View.extend({
    initialize: function() {
        _.each(this.model.comments.models, this.addComments, this);
    },
    addComments: function(comment) {
        // only add after save
        if ( ! comment.isNew() ) {
            this.views.add(new Huddle.CommentsPanelItemView({
                model: comment
            }));
        }
    }
});

/**
 * Comment Panel Items
 */
Huddle.CommentsPanelItemView = Huddle.View.extend( {
    className: 'ph-comment-panel-item',
    template: wp.template( 'panel-item' ),

    events: {
      'click': 'navigateComment'
    },

    navigateComment: function(e) {
        Huddle.state.set({
            'comment': this.model.get('id'),
            'panel': false
        }).trigger('change:comment', Huddle.state);
        e && e.preventDefault();
    }
});
/**
 * View to show our comment button
 *
 * @since 1.0
 */
Huddle.CommentSubmitButtonView = Huddle.View.extend({
    template: wp.template('project-comment-submit-button'),
    className: 'ph-button submit-comment',
    tagName: 'button',

    events: {
        'click': 'clicked'
    },

    triggers: {
        'identifySuccess' : 'submitComment',
        'submitComment': 'submitComment'
    },

	initialize: function () {
		this.listenTo(this.model.items, 'add remove sync change error', this.enableButton);

		_.bindAll(this, 'enableButton');
	},

	enableButton: function() {
		this.$el.prop("disabled", false)
	},

    /**
     * Handle Button Click
     */
    clicked: function () {
        if (!this.model.get('comment_content')) {
            return false;
        }
        this.model.trigger('submitComment');
        return false;
    },

    /**
     * Submits Comment
     */
    submitComment: function () {
        if ( ! Huddle.user.get('user_email') ) {
            Huddle.Event.trigger( 'requireIdentity', this.model );
            return false;
        }

        this.$el.prop("disabled", "disabled");

        // save and create item on success
        if (this.model.isNew()) { // save comment location
            this.model.save({},{
                success: _.bind(function(model, response) {
                    this.createItem(model);
					this.$el.prop("disabled", false);
                }, this),
                error: _.bind(function() {
                    console.error(arguments);
					this.$el.prop("disabled", false);
                }, this)
            });
        } else {
            this.createItem();
            this.model.set('comment_content', '');
        }
    },

    createItem: function (model) {
        if (typeof model === 'undefined' ) {
            model = this.model;
        }
		this.$el.prop("disabled", false);
        model.items.create({
            'comment_content': model.get('comment_content'),
            'comment_post_ID': model.get('id'),
            'comment_author': Huddle.user.get('display_name'),
            'comment_author_email': Huddle.user.get('user_email'),
            'avatar': '<img src="' + Huddle.gravatar(Huddle.user.get('user_email'), {
                size: 64,
                rating: 'r',
                backup: Huddle.options.global.avatar_default
            }) + '"/>'
        });
    }
});
/**
 * View to show our comment button
 *
 * @since 1.0
 */
Huddle.CommentSubmitControlsView = Huddle.View.extend({
    triggers: {
        'change:controls': 'controlsChangeHandler',
        'change:show': 'showChangeHandler'
    },

    initialize: function () {
        // submit button view
        this.views.add(new Huddle.CommentSubmitButtonView({
            model: this.model
        }));

        // cancel button view
        this.views.add(new Huddle.CommentCancelButtonView({
            model: this.model
        }));
    },

    ready: function () {
        this.showChangeHandler();
        this.controlsChangeHandler();
    },

    showChangeHandler: function () {
        !this.model.get('show') && this.model.set('controls', false);
    },

    controlsChangeHandler: function () {
        this.$el.toggle(this.model.get('controls'));
    }
});
/**
 * Comment view
 *
 * @since 1.0
 */
Huddle.CommentView = Huddle.View.extend({
    template : wp.template('project-comment'),
    className: 'ph-comment',

    events: {
        'mouseenter'               : 'hoverDot',
        "mouseleave"               : 'unHoverDot',
        'click'                    : 'clickDot',
        'keydown .ql-editor'       : 'cancelAutoHide',
        'click .ph-dropdown'       : 'cancelAutoHide',
        'hover .ph-item-controls i': 'cancelAutoHide',
        'click .ph-hide-bubble'    : 'hideComment',
        'focus .ql-editor'         : 'showComment'
    },

    triggers: {
        'destroy'              : 'destroyComment',
        'change:show'          : ['toggleShow', 'bodyClass'],
        'change:hover'         : 'toggleHover',
        'change:order'         : 'render',
        'change:x change:y'    : 'renderCoords',
        'change:scroll'        : 'scrollComment',
        'add'                  : 'render',
        'add change:x change:y': 'scrollBottom'
    },

    initialize: function () {
        // comment items
        _.each(this.model.items.models, function (item) {
            this.views.add('.ph-comment-text', new Huddle.CommentItemView({model: item}));
        }, this);

        // comment info for notifications
        this.views.set('.ph-comment-info', new Huddle.CommentInfoView({
            model: this.model
        }));

        // comment form view
        Huddle.permissions.get('allowComments') && this.views.set('.ph-comment-form', new Huddle.CommentFormView({
            model: this.model
        }));

        // comment controls
        this.views.set('.ph-comment-header', new Huddle.CommentHeaderView({
            model: this.model
        }));

        // submit controls
        this.views.set('.ph-comment-submit', new Huddle.CommentSubmitControlsView({
            model: this.model
        }));

        // render state
        this.listenTo(Huddle.state, 'change:comment', this.renderState);

        // do ready after image render
        this.listenTo(Huddle.Event, 'imageRender', this.ready);

        // when a new comment item is added to this collection, hide comment(s)
        this.listenTo(this.model.collection, 'add', this.hideComment);

        // when an item is saved, add view
        this.listenTo(this.model.items, 'add', this.addItemView);
        this.listenTo(this.model.items, 'add', this.scrollBottom);
        this.listenTo(this.model.items, 'add', this.checkEdges);
        this.listenTo(this.model.items, 'remove', this.checkEmpty);

        // autohide on save
        Huddle.options.global.auto_close && this.listenTo(this.model.items, 'add', this.autoHide);

        // bind this
        _.bindAll(this, 'sizeEvents', 'clickDot');
    },

    ready: function () {
        this.sizeEvents(); // size events
        this.toggleShow(); // show or hide if set in model
        this.bodyClass(); // body class
        this.renderCoords(); // render coordinates
        this.scrollBottom(); // scroll to bottom
        this.renderState(); // render state on load
        _.delay(_.bind(this.checkEdges, this), 0); // check edges, needs to be threaded

        Huddle.window.on('resize', this.sizeEvents);
        jQuery('.ph-project-image-outer').on('scroll', this.sizeEvents);
    },

    /**
     * Render coordinates
     */
    renderCoords: function () {
        this.$el.css({
            left: Math.max(0, this.model.get('x')),
            top : Math.max(0, this.model.get('y'))
        });
    },

    // change body class if comment is showing
    bodyClass: function () {
        Huddle.body.toggleClass('comment-showing', this.model.get('show'));
    },

    // scroll to bottom of comments div
    scrollBottom: function () {
        var text = this.$('.ph-comment-text');
        text.length && text.scrollTop(text.get(0).scrollHeight);
    },

    // add new comment item view
    addItemView: function (model) {
        this.views.add('.ph-comment-text', new Huddle.CommentItemView({
            model: model
        }));
    },

    // remove comment item view
    removeComment: function () {
        if (this.model.get('comment_content') && this.views.get('.ph-comment-form')[0].quill.getLength() > 1) {
            vex.dialog.confirm({
                message : Huddle.translations.discard ? Huddle.translations.discard : 'Are you sure you want to discard this comment without saving?',
                callback: _.bind(function (value) {
                    value && this.model.destroy();
                }, this)
            });
            return false;
        }

        this.model.destroy();
        return false;
    },

    // toggle show/hide comments
    toggleShow: function () {
        if (this.model.items.length < 1 && !this.model.get('show')) {
            this.removeComment();
            return false;
        }
        this.$el.toggleClass('ph-show-comments ph-hover-comments', this.model.get('show'));
    },

    // convenience function to show comment
    showComment: function () {
        this.model.set('show', true);
    },

    // convenience function to hide comment
    hideComment: function () {
        this.model.set('show', false);
    },

    // Event handler when dot is hovered
    hoverDot: function () {
        clearTimeout(this.hoverTimer);
        this.model.collection.forEach(_.bind(function (model, index) {
            model.set('hover', this.model.id === model.id);
        }, this));
    },

    // change hover class
    toggleHover: function () {
        this.$el.toggleClass('ph-hover-comments', this.model.get('hover'));
    },

    // unhover dot, small delay for ux
    unHoverDot: function () {
        this.hoverTimer = _.delay(_.bind(function () {
            this.model.set('hover', false)
        }, this), 750);
    },

    // clicked dot handler
    clickDot: function (e) {
        if ( jQuery(e.target).hasClass('ph-hide-bubble') )  {
            this.model.set({
                'hover': false,
                'show': false
            });
            return;
        }

        this.model.collection.forEach(_.bind(function (model, index) {
            model.set('show', this.model.id === model.id);
        }, this));
    },

    // Run on resize
    sizeEvents: function () {
        this.relativePosition();
        this.checkEdges();
        this.makeDraggable();
    },

    // auto hide comment after 1.5 seconds
    autoHide: function () {
        this.model.set({'show': true});
        this.hiding = _.delay(_.bind(function () {
            this.model.set({'show': false});
        }, this), 1500); // wait a second and a half
    },

    // kill autohide timer
    cancelAutoHide: function () {
        clearTimeout(this.hiding); //Kill the timer
    },

    // Place comment relative to parent container
    relativePosition: function () {
        var container = this.$('.ph-comment-inner').closest('.ph-project-image-inner');

        // set x/y coordinates
        this.model.set({
            'x': container.width() * this.model.get('relativeX'),
            'y': container.height() * this.model.get('relativeY')
        });
    },

    // Makes the element draggable to change the location
    makeDraggable: function () {
        // disable for non-moderate permissions
        if (!Huddle.permissions.get('moderate')) {
            return false;
        }

        // make draggable
        this.$el.draggable({
            start : this.clickDot,
            delay : 50,
            handle: ".ph-annotation-dot",
            cursor: "move",
            stop  : _.bind(this.stop, this)
        });
    },

    // when dragging stops
    stop: function (e, ui) {
        !this.model.isNew() && this.model.save({
            'x'        : ui.position.left,
            'y'        : ui.position.top,
            'relativeX': ui.position.left / this.$el.closest('.ph-project-image-inner').width(),
            'relativeY': ui.position.top / this.$el.closest('.ph-project-image-inner').height()
        }, {patch: true, validate: false});

        // check edges for left right position
        this.checkEdges();
        this.makeDraggable();
    },

    // functions to run to check edges of window
    checkEdges: function () {
        var w             = Huddle.window,
            inner         = this.$('.ph-comment-wrapper'),
            item          = this.$('.ph-comment-content'),
            dot           = this.$('.ph-annotation-dot'),
            top           = dot.offset().top,
            left          = inner.offset().left,
            thisHeight    = inner[0].scrollHeight + this.$('.ph-annotation-dot').outerHeight(),
            imageWrap     = jQuery('.ph-project-image-outer'),
            image         = jQuery('.ph-project-image'),
            heightItem    = image.height() < imageWrap.height() ? imageWrap : image,
            windowWidth   = w.width(),
            windowHeight  = heightItem.height(),
            hasRoom       = this.$el.offset().left + inner.outerWidth() + this.$('.ph-annotation-dot').outerWidth() + 30 < windowWidth,
            hasHeightRoom = this.$el.offset().top + w.scrollTop() > inner.outerHeight(),
            atBottom      = thisHeight + (top - heightItem.offset().top) > windowHeight,
            topClass      = atBottom && hasHeightRoom,
            diff          = item.outerWidth() + inner.offset().left - Huddle.window.width();

        inner.css({
            'max-width': w.width()
        });

        if ( diff <= 0 ) {
            this.$el.toggleClass('ph-comment-left', !hasRoom && atBottom && topClass);
            this.$el.toggleClass('ph-comment-top', topClass);
            item.css({
                'transform': 'translateX(0)'
            });
        }

        // if there's an overflow
        if (diff > 0) {
            this.$el.removeClass('ph-comment-left ph-comment-top');

            item.css({
                'max-width': Huddle.window.width()
            });

            if (item.height() > 0) {
                if (diff > 0) {
                    this.$el.removeClass('ph-comment-left ph-comment-top');
                    item.css({
                        'transform': 'translateX(' + -diff + 'px)'
                    });
                } else {
                    item.css({
                        'transform': 'translateX(0)'
                    });
                }
            } else {
                item.css({
                    'max-width': 'none'
                });
            }
        }
    },

    // Check state and show comment if necessary
    renderState: function () {
        if (Huddle.state.get('comment') == this.model.get('id')) {
            if (Huddle.state.get('commentText')) {
                this.model.set({'comment_content': Huddle.state.get('commentText')});
                this.$('.ql-editor').html(Huddle.state.get('commentText')).focus();
            }
            this.model.set({'show': true});
            this.scrollComment(); // scroll
            this.scrollBottom(); // scroll items list to bottom
        } else {
            !this.model.isNew() && this.model.set('show', false); // hide saved models
        }
    },

    // Scroll to the comment
    scrollComment: function () {
        var currentImage = Huddle.images.get(Huddle.state.get('image')),
            options = currentImage.get('options'),
            image = jQuery('.projecthuddle section#canvas .ph-project-image-outer');

        image.stop().animate({
            scrollTop : (this.model.get('y') - 60) + 'px',
			scrollLeft: (this.model.attributes.x - 20 - Huddle.window.width() / 2) + 'px'
        }, 500);
    },

    // remove comment thread if no comments
    checkEmpty: function () {
        this.model.items.length === 0 && this.destroyComment();
    },

    // when view is destroyed
    destroyComment: function () {
        jQuery(window).off("resize", this.sizeEvents);
        this.model.collection.remove(this.model);
        this.remove();
        this.unbind();
    }
});

/**
 * Control Bar View
 *
 * Subview of the image collection view that shows controls
 */
Huddle.ControlBarView = Huddle.View.extend({
    id: 'top-bar-inner',
    template: wp.template('control-bar'),
    tagName: 'div',

    events: {
        'click .ph-next-trigger': 'nextImage',
        'click .ph-prev-trigger': 'prevImage',
        'click .ph-share-trigger': 'triggerShare',
        'click .ph-login': 'triggerLogin',
        'click .mobile-more': 'mobileMenuClick'
    },

    triggers: {
        'change:mobileMenu': 'toggleMobileMenu',
    },

    animation: {
        hoverTimer: false
    },

    initialize: function () {
        this.model.images.length > 1 && this.views.add('.project-nav-controls', new Huddle.PrevNextView({
            model: this.model
        }));
        // image nav controls
        this.model.images.length > 1 && this.views.add('.project-controls', new Huddle.ImagesButtonView({
            model: this.model
        }));

        // comments navigator
        this.views.add('.project-controls', new Huddle.CommentsButtonWrapView({
            model: this.model
        }));

        // settings-dropdown
        this.views.add('.project-controls', new Huddle.SettingsDropdownContainerView({
            model: this.model
        }));

        // user dropdown
        this.views.add('.project-controls', new Huddle.UserDropdownView({
            model: this.model
        }));

        // image tray
        this.views.add('#ph-image-tray-wrap', new Huddle.ImageTrayView({
            model: this.model
        }));

        // show comments
        this.listenTo(Huddle.Event, 'showComments', this.showComments);

        this.listenTo(Huddle.user, 'change:id', this.render);

        // listen to close all global event
        this.listenTo(Huddle.Event, 'closeAll', this.closeThumbDrawer);

        // listen to state change of tray
        this.listenTo(Huddle.state, 'change:tray', this.restoreMobileMenu);

        // broadcast init
        wp.hooks.doAction('Huddle.ControlBarView.initialize', this);
    },

    /**
     * Once the dom is ready
     */
    ready: function () {
        // delegate events
        this.delegateEvents();
    },

    // mobile menu click handler
    mobileMenuClick: function() {
        this.model.set('mobileMenu', !this.model.get('mobileMenu'));
        return false;
    },

    // toggle mobile menu class
    toggleMobileMenu: function() {
        this.$el.toggleClass('open', this.model.get('mobileMenu'));
    },

    // restore menu when tray is closed
    restoreMobileMenu: function() {
        this.model.set('mobileMenu', !Huddle.state.get('tray'));
    },

    /**
     * Toggles thumb drawer
     */
    closeThumbDrawer: function () {
        Huddle.state.set('tray', false);
    },

    /**
     * Let anyone who's listening know the prev image link was clicked
     *
     * @param e
     */
    prevImage: function (e) {
        e.preventDefault();

        var prev    = false;
        var current = this.model.images.get(Huddle.state.get('image'));
        var index   = this.model.images.indexOf(current);

        if (index !== 0) {
            prev = this.model.images.at(index - 1);
        } else {
            prev = this.model.images.at(this.model.images.length - 1);
        }

        Huddle.router.navigate(prev.get('hash'), {trigger: true});
    },

    /**
     * Let anyone who's listening know the next image link was clicked
     *
     * @param e
     */
    nextImage: function (e) {
        e.preventDefault();

        var next    = false;
        var current = this.model.images.get(Huddle.state.get('image'));
        var index   = this.model.images.indexOf(current);

        if ((index + 1) < this.model.images.length) {
            next = this.model.images.at(index + 1);
        } else {
            next = this.model.images.at(0);
        }

        Huddle.router.navigate(next.get('hash'), {trigger: true});
    },

    /**
     * Enable Comments
     */
    showComments: function () {
        var body = jQuery('body');

        if (!body.hasClass('hide-comments')) {
            return;
        }

        this.$('.ph-toggle-comments').removeClass('disabled').find('i').removeClass('ion-eye-disabled');
        body.removeClass('hide-comments');
        Huddle.state.set('hideComments', false);
    },

    /**
     * Trigger share image event
     */
    triggerShare: function () {
        Huddle.Event.trigger('shareImage', this.model.images.get(Huddle.state.get('image')));
    },

    /**
     * Trigger login event
     */
    triggerLogin: function () {
        Huddle.Event.trigger('requireLogin', this.model.images.get(Huddle.state.get('image')));
    },

    /**
     * Mouse leave handler of thumb drawer
     */
    mouseLeaveThumbDrawer: function () {
        this.animation.hoverTimer = _.delay(_.bind(function () {
            Huddle.state.set('tray', false);
        }, this), 1000);
    },

    /**
     * Mouse enter handler of thumb drawer
     */
    mouseEnterThumbDrawer: function () {
        clearTimeout(this.animation.hoverTimer);
    }
});
/**
 * Comments Button Views
 */
Huddle.CommentsButtonWrapView = Huddle.View.extend({
    className: 'ph-comments-number-wrap',
    tagName: 'span',

    initialize: function () {
        this.listenTo(Huddle.state, 'change:image', this.setView);
    },

    setView: function (state) {
        this.views.set(new Huddle.CommentsButtonView({
            model: this.model.images.get(state.get('image'))
        }));
    }
});

/**
 * Comment Button
 */
Huddle.CommentsButtonView = Huddle.View.extend({
    id: 'nav-icon',
    template: wp.template('comments-button'),
    tagName: 'span',

    events: {
        'click': 'togglePanel'
    },

    // re-render when thread count changes
    initialize: function () {
        this.listenTo(this.model, 'change:thread_count', this.render);
    },

    togglePanel: function () {
        Huddle.state.set('panel', !Huddle.state.get('panel'));
        // close tray if panel and tray are open
        Huddle.state.get('tray') && Huddle.state.get('panel') && Huddle.state.set('tray', false);
        return false;
    }
});
/**
 * Image Nav View
 */
Huddle.ImagesButtonView = Huddle.View.extend( {
    id: 'nav-icon',
    template: wp.template( 'images-button' ),
    tagName: 'span',

    events: {
        'click ': 'toggleTray'
    },

    toggleTray: function () {
        Huddle.state.set('tray', !Huddle.state.get('tray'));

        // close tray if panel and tray are open
        if (Huddle.state.get('tray') && Huddle.state.get('panel')) {
            Huddle.state.set('panel', false);
        }
        return false;
    }
});
Huddle.PrevNextView = Huddle.View.extend({
    className: 'ph-prev-next-buttons',
    tagName: 'span',
    template: wp.template('prev-next-buttons')
});
// dropdown container
Huddle.SettingsDropdownContainerView = Huddle.View.extend({
    id: 'nav-icon',
    tagName: 'span',

    initialize: function () {
        this.listenTo(Huddle.state, 'change:image', this.setView);
    },

    /**
     * Adds the approval button with the right image state
     *
     * @param state State model
     */
    setView: function (state) {
        this.views.set(new Huddle.SettingsDropdownView({
            model: this.model.images.get(state.get('image'))
        }));
    }
});

// dropdown
Huddle.SettingsDropdownView = Huddle.View.extend({
    id: 'nav-icon',
    template: wp.template('settings-dropdown'),
    tagName: 'span'
});
/**
 * Image Nav View
 */
Huddle.UserDropdownView = Huddle.View.extend({
    id       : 'nav-icon',
    tagName  : 'span',
    className: 'ph-user ph-dropdown hover-trigger',

    initialize: function() {
        this.views.add(new Huddle.LoginAvatarView({
            model: Huddle.user
        }));
        this.views.add(new Huddle.LoginDropDownView({
            model: Huddle.user
        }));

        this.listenTo(Huddle.user, 'change', this.render);
    }
});

Huddle.LoginAvatarView = Huddle.View.extend({
    template : wp.template('login-avatar'),
    className: 'ph-avatar ph-select-text ph-control',
    tagName  : 'span',

    initialize: function () {
        this.listenTo(Huddle.user, 'change', this.render);
    }
});

Huddle.LoginDropDownView = Huddle.View.extend({
    template : wp.template('login-dropdown'),
    className: 'ph-select-dropdown ph-right-align ph-hidden',
    tagName  : 'span',

    events: {
        'click .ph-forget-me': 'forget',
        'click .ph-logout'   : 'logout'
    },

    initialize: function () {
        this.listenTo(Huddle.user, 'change', this.render);
    },

    forget: function () {
        Huddle.user.forget();
    },

    logout: function (e) {
        if ( !Cookies.get('Huddle.user') ) {
            return;
        }
        
        // Remember the link href
        var href = e.target.href;

        // Don't follow the link
        e.preventDefault();

        this.forget();

        window.location = href;
    }
});
/**
 * Copy Link Popup View
 *
 * Subview of the the dialog box that shows the copy link popup
 */
Huddle.CopyDialogView = Huddle.View.extend({

	template: wp.template( 'dialog-copy-link' ),

	events: {
		'click .ph-dialog-cancel': 'closeDialog',
		'click .ph-dialog-submit': 'closeDialog'
	},

	// broadcast init
	initialize: function() {
		// listen to close all global event
		this.listenTo( Huddle.Event, 'closeAll', this.closeDialog );

		wp.hooks.doAction( 'Huddle.CopyDialogView.initialize', this );
	},

	// render dialog box view
	render: function() {

		// cache this
		var base = this;

		// call the base class `render` method and we'll extend it
		wp.Backbone.View.prototype.render.apply(this, arguments);

		// open dialog
		this.dialog = vex.open( {
			content: this.el, // use template content
			afterOpen: function() {
				// trigger open event callback
				autosize( base.$el.find( 'textarea' ) );
				base.$el.find( 'textarea' ).select();
				base.model.trigger( 'dialogOpened', base.model, base );
			},
			afterClose: function () {
				// trigger close event callback
				base.model.trigger( 'dialogClosed', base.model, base );
				// remove view completely
				base.remove();
			}
		});

	},

	/**
	 * When dialog is cancelled
	 */
	closeDialog: function( e ) {

		e.preventDefault();
		e.stopPropagation();

		vex.close( this.dialog.data().vex.id );
		Huddle.Event.trigger( 'dialogClosed', this.model );
	}
} );
/**
 * Controls the various dialog boxes needed for the plugin
 *
 * @since 1.0
 */
Huddle.DialogView = Huddle.View.extend( {

	initialize: function () {

		// listen for need identity dialog in current image comments
		Huddle.Event.on( 'requireIdentity', this.identifyPopup, this );

		// listen for need identity dialog in current image comments
		Huddle.Event.on( 'requireLogin', this.loginPopup, this );

		// listen for need identity dialog in current image comments
		Huddle.Event.on( 'shareImage', this.sharePopup, this );

		// listen for need identity dialog in current image comments
		Huddle.Event.on( 'shareComment', this.shareCommentPopup, this );

		// listen for need identity dialog in current image comments
		Huddle.Event.on( 'copyCommentLink', this.copyCommentLinkPopup, this );

		// broadcast init
		wp.hooks.doAction( 'Huddle.DialogView.initialize', this );
	},

	/**
	 * Create identify popup view and render
	 *
	 * @param model {object} Model to use for popup
	 */
	identifyPopup: function ( model ) {
		new Huddle.IdentifyDialogView( {
			model: model
		} ).render();
	},

	/**
	 * Create login popup view and render
	 *
	 * @param model {object} Model to use for popup
	 * @param backEvent {string} Optional event to call for back button
	 */
	loginPopup: function ( model, backEvent ) {
		new Huddle.LoginDialogView( {
			model: model,
			backEvent: backEvent
		} ).render();
	},

	/**
	 * Create share popup and render
	 */
	sharePopup: function( model ) {

		// current project
		model.set( 'share_link', Huddle.baseURL );

		// create and render view
		new Huddle.ShareDialogView( {
			model: model
		} ).render();
	},

	/**
	 * Create share popup and render
	 *
	 * @param model {object} Model to use for popup
	 */
	shareCommentPopup: function( model ) {
		// share comment on current image
		model.set( 'share_link', Huddle.baseURL + '#' + Huddle.images.get(Huddle.state.get('image')).get('hash') + '/comment/' + model.get('id') );

		// create and render view
		new Huddle.ShareDialogView( {
			model: model
		} ).render();
	},

	/**
	 * Create share popup and render
	 *
	 * @param model {object} Model to use for popup
	 */
	copyCommentLinkPopup: function( model ) {
		// share comment on current image
		model.set( 'share_link', Huddle.baseURL + '#' + Huddle.images.get(Huddle.state.get('image')).get('hash') + '/comment/' + model.get('id') );

		// create and render view
		new Huddle.CopyDialogView( {
			model: model
		} ).render();
	}
} );
/**
 * Identify Popup View
 *
 * Subview of the the dialog box that shows the identify popup
 */
Huddle.IdentifyDialogView = Huddle.View.extend({
    template: wp.template('dialog-identify'),

    events: {
        'click .vex-dialog-button': 'cancelDialog',
        'click .ph-dialog-login': 'loginDialog',
        'click .ph-dialog-submit': 'submit',

        "keyup input[type='email']": "emailChangeHandler",
        "input input[type='email']": "emailChangeHandler",
        "paste input[type='email']": "emailChangeHandler",
        "change input[type='email']": "emailChangeHandler"
    },

    // broadcast init
    initialize: function () {
        wp.hooks.doAction('Huddle.IdentifyDialogView.initialize', this);
    },

    // render dialog box view
    render: function () {

        // cache this
        var base = this;

        // call the base class `render` method and we'll extend it
        wp.Backbone.View.prototype.render.apply(this, arguments);

        this.submitButton = this.$el.find('button[type="submit"]');
        this.emailInput   = this.$el.find('input[type="email"]');

        // open dialog
        this.dialog = vex.open({
            content: this.el, // use template content
            afterOpen: function ($vexContent) {
                // trigger open event callback
                base.model.trigger('dialogOpened', base.model, base);

                base.submitButton = base.$el.find('button[type="submit"]');
                base.submitButton.attr('disabled', true);
            },
            afterClose: function () {
                // trigger close event callback
                base.model.trigger('dialogClosed', base.model, base);
                // remove view completely
                base.remove();
            }
        });

    },

    cancelDialog: function () {
        vex.close(this.dialog.data().vex.id);
        this.model.trigger('dialogCancelled', this.model);
    },

    loginDialog: function () {
        vex.close(this.dialog.data().vex.id);
        Huddle.Event.trigger('requireLogin', this.model, 'requireIdentity');
    },

    /**
     * Get all form data and convert to array
     *
     * @returns Array of field names with values
     */
    getFormData: function () {

        var arr = this.$el.find('form').serializeArray();

        return _(arr).reduce(function (acc, field) {
            acc[field.name] = field.value;
            return acc;
        }, {});
    },

    isEmail: function (email) {
        var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
        return regex.test(email);
    },

    /**
     * Handle email box change
     *
     * @param e
     */
    emailChangeHandler: function (e) {
        this.checkValidEmail(e.currentTarget.value);
    },

    /**
     * Checks valid email and enables or disables submit button
     *
     * @param $value
     */
    checkValidEmail: function ($value) {
        if (this.isEmail($value)) {
            this.emailInput.removeClass('ph-error');
            this.submitButton.attr('disabled', false);
        } else {
            this.emailInput.addClass('ph-error');
            this.submitButton.attr('disabled', true);
        }

        if (!$value || $value == '') {
            this.emailInput.removeClass('ph-error');
        }
    },

    /**
     * Submit form handler
     * @param e
     */
    submit: function (e) {
        e.preventDefault();
        e.stopPropagation();

        var data = this.getFormData();

        Huddle.user.set({
            'display_name': data.username,
            'user_email': data.email
        });

        Cookies.set('Huddle.user', Huddle.user);

        this.model.trigger('identifySuccess', this.model)
    }
});
/**
 * Control Bar View
 *
 * Subview of the image collection view that shows controls
 */
Huddle.ImageThumbView = Huddle.View.extend({
    className: 'ph-nav-thumb-link',
    template: wp.template('image-thumb'),
    tagName: 'span',

    events: {
        'click': 'navigateImage'
    },

    initialize: function () {
        // when comment count changes, re-render
        this.listenTo(this.model, 'change:comment_count', this.render);

        // broadcast init
        wp.hooks.doAction('Huddle.ImageThumbView.initialize', this);
    },

    navigateImage: function () {
        Huddle.router.navigate(this.model.get('hash'), {trigger: true});
    }
});
Huddle.ImageTrayView = Huddle.View.extend({
    id      : 'ph-thumbs-navigator',
    template: wp.template('image-tray'),

    events: {
        'click .ph-toggle-nav': 'closeTray'
    },

    initialize: function () {
        // comment items
        _.each(this.model.images.models, function (image) {
            this.views.add('#ph-thumb-nav-inner', new Huddle.ImageThumbView({
                model: image
            }));
        }, this);

        this.listenTo(Huddle.state, 'change:tray', this.showHideTray);

        // broadcast init
        wp.hooks.doAction('Huddle.ImageTrayView.initialize', this);
    },

    closeTray: function () {
        Huddle.state.set('tray', false);
    },

    showHideTray: function (state) {
        this.$el.toggleClass('ph-show', state.get('tray'));
    }
});
/**
 * View to show our individual image
 * Creates models and views for new comments
 *
 * @since 1.0
 */

Huddle.ImageView = Huddle.View.extend({
    template: wp.template('project-image'),
    className: 'ph-project-image-outer',

    events: {
        "click img.ph-project-image"    : 'imageClicked',
        'touchstart img.ph-project-image, touchmove img.ph-project-image, touchend img.ph-project-image': 'touchTool',
        "mouseenter img.ph-project-image": "hideTray",
        "mouseleave img.ph-project-image": "resetTray"
    },

    options : {},

    /**
     * Set templates and listen for model events
     */
    initialize: function () {
		// store image view options
        this.options = this.model.get('options');

        // add comment views
        _.each(this.model.comments.models, this.loadAnnotations, this);

        this.views.add('.ph-image-controls', new Huddle.ImageZoomView({
            model: this.model
        }));

        // when a new model is added to the collection, render it
        this.listenTo(this.model.comments, 'add', this.renderComment);
        this.listenTo(this.model.comments, 'add', this.maybeMobileScroll);

        // zoom events
        this.listenTo(this.model, 'change:zoom', this.zoom);
        this.model.set('magnification', 1);

        // if comments aren't allowed
        if ( ! Huddle.permissions.get('allowComments') ) {
            this.$('img.ph-project-image').off();
        }

        jQuery(window).resize(_.bind(this.setScroll, this));

        // broadcast init
        wp.hooks.doAction('Huddle.ImageView.initialize', this);
    },

    /**
     * Delegate events when ready
     */
    ready: function () {
        this.loadImage();
    },

    loadImage: function() {
        // hide
        this.$el.css('opacity', 0);

        var image = this.$('img.ph-project-image');

        // get the image src so it can be put back in to convince IE to run the .load() function correctly
        var imgSrc = image.attr("src");

        if ( ! image.prop('complete') ) {
            this.$('img.ph-project-image').on('load',
                _.bind(function(){
                    this.setImage();
                    this.fadeImage();
                }, this)
            ).attr("src", imgSrc); //makes .load() work in IE when images are cached
        } else {
            this.setImage();
            this.$el.css('opacity', 1);
        }

        this.$('img.ph-project-image').on('load', function(){ Huddle.Event.trigger('imageRendered') }).attr("src", imgSrc); //makes .load() work in IE when images are cached;
    },

    zoom: function() {
        var w     = jQuery(window),
            image = this.$('img.ph-project-image');

        // find center of image on screen from left/top in px
        var offsetLeft = this.$el.scrollLeft() + (w.width()/2);
        var offsetTop = this.$el.scrollTop() + (w.height()/2);

        // get percentage of image to center
        var percentageCenterX = offsetLeft / this.el.scrollWidth;
        var percentageCenterY = offsetTop / this.el.scrollHeight;

        if (this.model.get('zoom') === 'in') {
            image.width(image.width() * this.model.get('zoomAmount'));
        } else {
            image.width(image.width() / this.model.get('zoomAmount'));
        }

        // override fixed scale class if zoomed in
        if ( this.options.ph_image_size === 'scale' ) {
            image.toggleClass('scale-override', this.model.get('magnification') > 1);
            if ( this.model.get('magnification') === 1 ) {
                image.css('width', '');
            }
        }

        jQuery(window).trigger('resize'); // trigger position of comments

        this.$el.scrollLeft(percentageCenterX * this.el.scrollWidth - (w.width()/2));
        this.$el.scrollTop(percentageCenterY * this.el.scrollHeight - (w.height()/2));
    },

    maybeMobileScroll: function (model) {
        Huddle.window.width() <= 780 && model.set('scroll', true);
    },

    /**
     * Gets image options and displays image properly
     */
    imageOptions: function () {
        // expect options
        if (!this.options) return;

        // image alignment
        if (this.options.ph_image_alignment) {
            this.$el.addClass('ph-alignment-' + this.options.ph_image_alignment);
        }

        // size/zoom behavior class
        this.options.ph_image_size && this.$el.addClass('ph-size-' + this.options.ph_image_size);

        // background-color
        this.options.ph_image_background_color && this.$el.css('background-color', this.options.ph_image_background_color);

        // background image
        this.options.ph_image_background_image && this.$el.css('background-image', 'url(' + this.options.ph_image_background_image + ')');

        // background image position
        if (this.options.ph_image_background_image_position) {

            // center image no matter what
            this.$el.css('background-position', 'top center');

            switch (this.options.ph_image_background_image_position) {
                case 'center':
                    this.$el.css('background-repeat', 'no-repeat');
                    break;
                case 'repeat':
                    this.$el.css('background-repeat', 'repeat');
                    break;
                case 'repeat-x':
                    this.$el.css('background-repeat', 'repeat-x');
                    break;
                case 'cover':
                    this.$el.css('background-size', 'cover');
                    this.$el.css('-webkit-background-size', 'cover');
                    this.$el.css('-mox-background-size', 'cover');
                    this.$el.css('-ms-background-size', 'cover');
                    break;
            }
        }

        this.setScroll();
    },

    setScroll: function () {
		if (!this.options.ph_image_alignment) {
			return;
		}

		// center on scroll
		if (this.options.ph_image_alignment == 'center') {
			var containerWidth = jQuery(window).width(),
			    image = new Image(),
                thisWidth;

			// get natural image width
			image.src = this.$el.find('img.ph-project-image').attr("src");
			thisWidth = image.naturalWidth;

			// half for retina
			if ( 'on' === this.model.get('retina') ) {
			    thisWidth = thisWidth /2;
            }

			var difference = thisWidth < containerWidth ? (containerWidth - thisWidth ) / 2 : -(containerWidth - thisWidth ) / 2;
			this.$el.scrollLeft(difference);
		}
		if (this.options.ph_image_alignment == 'right') {
			this.$el.scrollLeft(this.$el.width());
		}
    },

    /**
     * Scrolltop, fade in image
     */
    setImage: function ( fade ) {
        // set retina option
        this.setRetina();

        // set image display options
        this.imageOptions();

        // add scrollbar, scroll to top
        this.$el.scrollTop();

        this.originalWidth = this.$('img.ph-project-image').width();

        // trigger render
        Huddle.Event.trigger('imageRender');
    },

    fadeImage: function() {
        this.$el.animate({'opacity': 1}, 250, function () {
            Huddle.Event.trigger('imageRendered');
        });
    },

    /**
     * Retina specific css
     */
    setRetina: function () {
        if ('on' == this.model.attributes.retina) {
            var thisImage = this.$('.ph-project-image');
            var thisWidth = thisImage.width();

            thisImage.css({
                'width': thisWidth / 2,
                'height': 'auto'
            });
        }
    },

    /**
     * Load existing annotation dots
     *
     * @param comment Model to use for the comment view
     */
    loadAnnotations: function (comment) {
        // create a new subview for each comment
        this.views.add('.ph-image-comments-container', new Huddle.CommentView({
            model: comment,
            parent: this
        }));
    },

    /**
     * Handler to check what happens when the image is clicked
     *
     * @param e Click event
     */
    imageClicked: function (e) {
        // ignore right and middle click
        if (e && ( e.which == 2 || e.which == 3 )) return false;

        // only if comments are allowed
        if (!Huddle.permissions.get('allowComments')) {
            toastr.error(Huddle.translations.login_required);
            return false;
        }

        // check bubble
        if (this.bubbleCheck(e, _.bind(this.annotateImage, this)) == false) {
            return false;
        }

        Huddle.state.set({
            'tray': false,
            'panel': false
        });

        // annotate image
        this.annotateImage(e);

        // prevent default click functionality
        e.stopPropagation();
        return false;
    },

    /**
     * Checks existing bubbles before callback
     *
     * @param options Callback options
     * @param callback Callback Function
     * @returns {boolean} Continue with parent function
     */
    bubbleCheck: function (options, callback) {
        // get any new comments
        var newComment = this.model.comments.find(_.bind(function (model) {
            return this.model.isNew();
        }, this));

        // remove new comment
        if (newComment) {

            // confirm dialog if new comment text is entered
            if (newComment.attributes.newCommentText) {
                this.discardConfirm(newComment, options, callback);
                // don't annotate
                return false;
            }

            this.model.comments.remove(newComment);

            // continue annotation
            return true;
        }
    },

    discardConfirm: function (commentModel, options, callback) {
        vex.dialog.confirm({
            message: Huddle.translations.discard ? Huddle.translations.discard : 'Discard your comment?',
            callback: _.bind(function (value) {
                if (!value) return false;

                // remove comment
                this.model.comments.remove(commentModel);

                // callback function
                callback && callback(options);

                // don't annotate
                return false;
            }, this)
        });
    },

    /**
     * Annotates Image
     *
     * @param e event object
     * @param xpos (optional) X coordinate to programatically add x position
     * @param ypos (optional) Y coordinate to programatically add y position
     */
    annotateImage: function (e, xpos, ypos) {
        // if click event, calculate offsets
        if (typeof e != 'undefined' && e) {
            if (typeof xpos == 'undefined' || typeof ypos == 'undefined') {
                xpos = e.pageX - jQuery(e.currentTarget).offset().left;
                ypos = e.pageY - jQuery(e.currentTarget).offset().top;
            }
        }

        // add comment model to collection
        this.model.comments.add(new Huddle.Comment({
            imageID: this.model.get('id'),
            x: parseFloat(xpos), // set left click position
            y: parseFloat(ypos), // set top click position
            relativeX: parseFloat(this.relativeX(e.offsetX)), // store right relative position
            relativeY: parseFloat(this.relativeY(e.offsetY)), // store relative top position
            show: true,
            focus: true
        }));
    },

    /**
     * add comment view to subviews
     */
    renderComment: function (comment) {
        this.views.add('.ph-image-comments-container', new Huddle.CommentView({
            model: comment
        }));
    },

    /**
     * Gets relative x position depending on parent width
     */
    relativeX: function (posLeft) {
        var width = this.$('.ph-project-image-inner').width();
        return posLeft / width;
    },

    /**
     * Gets relative y position depending on parent width
     */
    relativeY: function (posTop) {
        var height = this.$('.ph-project-image-inner').height();
        return posTop / height;
    },

    hideTray: function() {
        this.hoverTimer = _.delay(_.bind(function () {
            Huddle.state.set('tray', false);
        }, this), 350);
    },

    resetTray: function() {
        clearTimeout(this.hoverTimer);
    }
});
Huddle.ImageZoomView = Huddle.View.extend({
    className: 'ph-project-zoom-wrap',
    initialize: function () {
        // subviews
        this.views.add(new Huddle.ZoomPercentView({
            model: this.model
        }));
        this.views.add(new Huddle.ZoomView({
            model: this.model
        }));
    },
    ready: function () {
        Huddle.options.project.zoom === 'off' && this.$el.addClass('ph-hidden'); // hide if turned off
    }
});

Huddle.ZoomView = Huddle.View.extend({
    template: wp.template('image-zoom-controls'),
    className: 'ph-zoom-controls',
    events: {
        'click .ph-zoom-in': 'zoomIn',
        'click .ph-zoom-out': 'zoomOut'
    },
    ready: function () {
        this.$('.ph-zoom-in, .ph-zoom-out').nodoubletapzoom();
    },
    zoomIn: function () {
        this.model.set({'zoom': 'in'}, {silent: true}).trigger('change:zoom', this.model);
    },
    zoomOut: function () {
        this.model.set({'zoom': 'out'}, {silent: true}).trigger('change:zoom', this.model);
    }
});

Huddle.ZoomPercentView = Huddle.View.extend({
    template: wp.template('image-zoom-percent'),
    className: 'ph-zoom-percent',
    initialize: function () {
        this.listenTo(this.model, 'change:zoom', this.render);
    }
});
/**
 * Login Dialog View
 *
 * Subview of the the dialog box that shows the dialog popup
 */
Huddle.LoginDialogView = Huddle.View.extend({
    template: wp.template('dialog-login'),

    events: {
        'click .ph-dialog-cancel': 'cancelDialog',
        'click .ph-dialog-submit:enabled': 'loginUser'
    },

    // broadcast init
    initialize: function () {
        wp.hooks.doAction('Huddle.LoginDialogView.initialize', this);
    },

    // render dialog box view
    render: function () {
        // call the base class `render` method and we'll extend it
        wp.Backbone.View.prototype.render.apply(this, arguments);

        // open dialog
        this.dialog = vex.open({
            // use template content
            content: this.el,
            overlayClosesOnClick: false,
            afterOpen: _.bind(function () {
                this.model.trigger('dialogOpened', this.model, this);
            }, this),
            afterClose: _.bind(function () {
                this.model.trigger('dialogClosed', this.model, this);
                this.remove();
            }, this)
        });
    },

    /**
     * When dialog is cancelled
     */
    cancelDialog: function () {
        // trigger back event if it exists
        this.options.backEvent && Huddle.Event.trigger(this.options.backEvent, this.model);

        // close dialog
        vex.close(this.dialog.data().vex.id);

        // trigger dialog cancelled
        Huddle.Event.trigger('dialogCancelled', this.model);
    },

    /**
     * Get all form data and convert to array
     *
     * @returns Array of field names with values
     */
    getFormData: function () {
        var arr = this.$el.find('form').serializeArray();

        return _(arr).reduce(function (acc, field) {
            acc[field.name] = field.value;
            return acc;
        }, {});
    },

    /**
     * Sets username and password, runs login function
     */
    loginUser: function (e) {
        // prevent defaults
        e.preventDefault();
        e.stopPropagation();

        var data = this.getFormData();

        Huddle.user.save({
            'username': data.username,
            'password': data.password
        }, {
            wait: true,
            url: Huddle.user.urlRoot + '/login',
            success: _.bind(function() {
                Huddle.state.set({
                    'comment': this.model.get('id'),
                    'commentText': this.model.get('comment_content'),
                    'x': this.model.get('x'),
                    'y': this.model.get('y')
                });
                localStorage.setItem( 'ph_state', JSON.stringify(Huddle.state) );
                Huddle.Event.trigger( 'loginSuccess' );
            }, this)
        });
    }
});
/**
 * Top level view that orchestrates the front-end experience.
 *
 * Extends Huddle.View mixin
 *
 * this.model holds the entire images collection and all subdata
 *
 * @since 1.0
 */
Huddle.ProjectHuddleView = Huddle.View.extend({
    className: "project-huddle-inner",
    template: wp.template('project-image-collection'),

    events: {
        "mousemove": "toolTrack",
        'mouseenter .ph-dropdown.hover-trigger': 'hoverMenu',
        'mouseleave .ph-dropdown.hover-trigger': 'unHoverMenu',
        'click .ph-dropdown.click-trigger': 'toggleSelectMenu'
    },

    initialize: function () {
        // add side panel
        this.views.set('.ph-side-panel', new Huddle.CommentsPanelView({
            model: this.model
        }));

        // set control bar
        this.views.set('#top-bar', new Huddle.ControlBarView({
            model: this.model
        }));

        // when image state changes, render it
        this.listenTo(Huddle.state, 'change:image', this.setImage);
        this.listenTo(Huddle.state, 'change:image', this.showLoading);
        this.listenTo(Huddle.Event, 'imageRendered', this.hideLoading);

        // broadcast init
        wp.hooks.doAction('Huddle.ProjectHuddleView.initialize', this);
    },

    ready: function () {
        this.dropdownPosition();

        // add tooltip
        this.tooltip = Huddle.options.project.tooltip ? jQuery('.ph-image-tip') : false;
        this.tooltip = Huddle.permissions.get('allowComments') ? this.tooltip : false;
        
        jQuery(window).on('resize scroll', _.bind(this.dropdownPosition, this));
    },

    /**
     * Make tooltip track mouse pointer
     *
     * @param {event} e Event object
     */
    toolTrack: function (e) {
        if ( e.target.className == 'ph-project-image' ) {
            this.displayTool();
            this.tooltip && this.tooltip.css({
                left: e.pageX + 'px',
                top: e.pageY + 'px'
            });
        } else {
            this.hideTool();
        }
    },

    /**
     * Shows tooltips
     */
    displayTool: function (e) {
        this.tooltip && this.tooltip.stop().fadeIn(100);
    },

    touchTool: function() {
        this.$el.off('mousemove');
        this.resetTool();
    },

    hideTool: function () {
        this.tooltip && this.tooltip.stop().fadeOut(100);
    },

    resetTool: function() {
        this.tooltip && this.tooltip.css({
            'top': '-99999px',
            'left': '-99999px'
        });
    },

    dropdownPosition: function() {
        jQuery('.ph-select-dropdown').each(function () {
            var left = jQuery(this).offset().left;
            if (left < 0) {
                jQuery(this).css('margin-right', -Math.abs(left));
            }
        });
    },

    hideLoading: function() {
        this.$('.ph-loading').hide();
    },

    showLoading: function() {
        this.$('.ph-loading').show();
    },

    /**
     * Sets the correct image on the canvas when the state changes
     *
     * @param state State model
     */
    setImage: function (state) {
        this.views.set('#canvas', new Huddle.ImageView({
            model: this.model.images.get(state.get('image'))
        }));
    },

    /**
     * Store animation classes
     */
    animation: {
        hoverTimer: false
    },

    toggleSelectMenu: function (e) {
        jQuery(e.currentTarget).find('.ph-select-dropdown').fadeToggle(150);
    },

    /**
     * Event handler when menu is hovered
     *
     * @param e Event
     */
    hoverMenu: function (e) {
        clearTimeout(this.animation.hoverTimer);
        jQuery('.ph-select-dropdown').stop().fadeOut(150);
        jQuery(e.currentTarget).find('.ph-select-dropdown').stop().fadeIn(150);
    },

    /**
     * Event handler when menu is unhovered
     *
     * @param e Event
     */
    unHoverMenu: function (e) {
        this.animation.hoverTimer = setTimeout(function () {
            jQuery(e.currentTarget).find('.ph-select-dropdown').stop().fadeOut(150);
        }, 500);
    }
});
/**
 * Share Popup View
 *
 * Subview of the the dialog box that shows the identify popup
 */
Huddle.ShareDialogView = Huddle.View.extend({

	template: wp.template( 'dialog-share' ),

	events: {
		'click .ph-dialog-cancel': 'closeDialog',
		'click .ph-dialog-submit:enabled': 'shareImage',
		"focus .ph-share-message": "elastic"
	},

	ui: {
		textAreaHeight: false
	},

	initialize: function() {
		// close dialog on success
		this.listenTo(this.model, 'sync', this.closeDialog );

		// broadcast init
		wp.hooks.doAction( 'Huddle.ShareDialogView.initialize', this );
	},

	// render dialog box view
	render: function() {
		// cache this
		var base = this;

		// call the base class `render` method and we'll extend it
		wp.Backbone.View.prototype.render.apply(this, arguments);

		if ( !Huddle.permissions.get('allowComments')) {
			toastr.error(Huddle.translations.no_permission);
			return false;
		}

		// check user identity
		if ( ! Huddle.user.attributes.user_email ) {
			// trigger identity requirement
			Huddle.Event.trigger( 'requireIdentity', this.model );
			return false;
		}

		// open dialog
		this.dialog = vex.open( {
			className: 'vex-theme-default',
			content: this.el, // use template content
			afterOpen: function() {
				// trigger open event callback
				base.model && base.model.trigger( 'dialogOpened', base.model, base );
			},
			afterClose: function () {
				// trigger close event callback
				base.model && base.model.trigger( 'dialogClosed', base.model, base );
				// remove view completely
				base.remove();
			},
			escapeButtonCloses: false,
			overlayClosesOnClick: false
		});
	},

	/**
	 * When dialog is cancelled
	 */
	closeDialog: function() {
		vex.close( this.dialog.data().vex.id );
		Huddle.Event.trigger( 'dialogClosed', this.model );
	},

	getFormData: function() {
		var arr = this.$el.find('form').serializeArray();
		var data = _(arr).reduce(function(acc, field) {
			acc[field.name] = field.value;
			return acc;
		}, {});

		return data;
	},

	/**
	 * Elasicizes textarea
	 */
	elastic: function( e ){
		autosize( e.currentTarget );
	},

	/**
	 * Sets username and password, runs login function
	 */
	shareImage: function( e ) {
		e.preventDefault();
		e.stopPropagation();


		var data = this.getFormData();

		// check honeypot
		if ( data.website != 0 ) {
			return false;
		}

		// add user to data
		data.user = Huddle.user ? Huddle.user : false;

		// add share link
		if ( this.model.attributes.share_link ) {
			data.link = this.model.attributes.share_link;
		} else {
			data.link = Huddle.baseURL;
		}

        this.model.save({
            'email'     : data,
            'project_id': Huddle.projectID,
            'image_id'  : Huddle.state.get('image'),
            'user'      : Huddle.user
        }, {
            url: Huddle.apiURL + 'mockup/image/' + this.model.get('id') + '/actions/share',
            patch: true,
			success: _.bind(function() {
            	toastr.success(Huddle.translations.email_sent ? Huddle.translations.email_sent : 'Email sent!');
			}, this)
        });
	}
} );
/**
 * Router that controls routes for the project front end
 *
 * @since 1.0.0
 */
Huddle.ProjectRouter = Backbone.Router.extend({

    routes: {
        "": "noHash",
        ":hashID(/)(comment)(/)(:commentid)(/)(comment-text)(/)(:commentText)(/)(x)(/)(:xCoord)(/)(y)(/)(:yCoord)(/)": "imageRoute",
        "#": 'noHash'
    },

    // fired before every route
    execute: function (callback, args) {
        this.trigger('beforeRoute');
        if (callback) callback.apply(this, args);
        this.trigger('afterRoute');
    },

    /**
     * On successful login
     */
    initialize: function () {
        // when person is properly logged in, reload to get new nonces
        Huddle.Event.on('loginSuccess', this.loginReload);

        // update the url when requested with current state information
        Huddle.Event.on('updateStateURL', this.updateStateURL);

        // reset url when requested
        Huddle.Event.on('resetURL', this.resetURL);

        // broadcast init
        wp.hooks.doAction('Huddle.ProjectRouter.initialize', this);
    },

    /**
     * Reload page on successful login
     */
    loginReload: function () {
        window.onbeforeunload = null;
        window.location.reload();
    },

    /**
     * If nothing found, go to error 404
     */
    sessionExpired: function () {
        var noImagesString = Huddle.translations.session_expired ? Huddle.translations.session_expired : 'Your session expired. Please reload the page.';
        // swap out new view
        Huddle.container.$('#canvas').html('<div class="ph-no-images">' + noImagesString + '</div>');
        Huddle.container.$('.ph-loading').remove();
    },

    /**
     * Go to first image if no hash is entered
     */
    noHash: function () {
        var firstImage = Huddle.images.first(),
            hash;

        // make sure there's one image
        if (typeof firstImage != 'undefined') {
            hash = firstImage.attributes.hash;
            this.navigate(hash, {trigger: true});
        } else {
            this.noImages();
        }
    },

    /**
     * If nothing found, go to error 404
     */
    notFound: function () {
        var noImagesString = Huddle.translations.image_not_found ? Huddle.translations.image_not_found : 'Image doesn\'t exist or cannot be found.';
        // swap out new view
        Huddle.container.$('#canvas').html('<div class="ph-no-images">' + noImagesString + '</div>');
        Huddle.container.$('.ph-loading').remove();
    },

    noImages: function () {
        var noImagesString = Huddle.translations.no_images ? Huddle.translations.no_images : 'No images found.';

        // notify
        Huddle.container.$('#canvas').html('<div class="ph-no-images">' + noImagesString + '</div>');
        Huddle.container.$('.ph-loading').remove();
    },

    /**
     * Loads image view into collection based on index
     *
     * @param hashID {string} Index of view in collection
     * @param commentid {mixed} ID of comment or string for new
     * @param commentText {string} Comment Text
     * @param xCoord {int} X coordinate of comment
     * @param yCoord {int} Y coordinate of comment
     */
    imageRoute: function (hashID, commentid, commentText, xCoord, yCoord) {
        // get state from localstorage if it exists
        var local = JSON.parse(localStorage.getItem( 'ph_state' ));
        if ( local ) {
            Huddle.state.set({
                'comment': local.comment,
                'commentText': local.commentText,
                'image': local.image,
                'x': local.x,
                'y': local.y
            });
            localStorage.removeItem('ph_state');
            return;
        }

        // get image model by hash
        var image = Huddle.images.find(function (model) {
            return model.get('hash') == hashID;
        });

        // check if it exists, if not, notFound
        if (typeof image == 'undefined') {
            this.notFound();
            return false;
        }

        // set states
        Huddle.state.set({
            'image': image.get('id'),
            'comment': parseInt(commentid),
            'commentText': commentText ? commentText : false,
            'x': xCoord ? xCoord : false,
            'y': yCoord ? yCoord : false
        });
    },

    /**
     * Updates the url based on the state
     */
    updateStateURL: function () {
        var state = Huddle.state,
            image = Huddle.images.get(state.get('image')),
            url   = [
                image.get('hash') ? image.get('hash'): '',
                state.get('comment') ? '/comment/' + state.get('comment') : '',
                state.get('commentText') ? '/comment-text/' + state.get('commentText') : '',
                state.get('x') ? '/x/' + state.get('x') : '',
                state.get('y') ? '/y/' + state.get('y') : ''
            ];

        Huddle.router.navigate(encodeURI(url.join("")), {replace: true});
    },

    /**
     * Clear url to current image only
     */
    resetURL: function () {
        Huddle.router.navigate('', {replace: true});
    }
});
/**
 * Setup page events and collections
 *
 * @package     ProjectHuddle
 * @subpackage  js
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */

(function($){

    var isIOS = /iphone|ipad/i.test(navigator.userAgent);
    $.fn.nodoubletapzoom = function () {
        if (isIOS) {
            $(this).bind('touchstart', function preventZoom(e) {
                var t2      = e.timeStamp,
                    t1      = $(this).data('lastTouch') || t2,
                    dt      = t2 - t1,
                    fingers = e.originalEvent.touches.length;

                $(this).data('lastTouch', t2);

                // not double-tap
                if (!dt || dt > 500 || fingers > 1) {
                    return;
                }

                e.preventDefault(); // double tap - prevent the zoom
                // also synthesize click events we just swallowed up
                $(this).trigger('click').trigger('click');
            });
        }
    };

    /**
     * Setup Page
     *
     * @since 1.0
     */
    $(document).ready(function(){

        toastr.options = {
            "closeButton": true,
            "debug": false,
            "newestOnTop": true,
            "progressBar": true,
            "positionClass": "toast-bottom-right",
            "onclick": null,
            "showDuration": "300",
            "hideDuration": "1000",
            "timeOut": "5000",
            "extendedTimeOut": "1000",
            "showEasing": "swing",
            "hideEasing": "linear",
            "showMethod": "fadeIn",
            "hideMethod": "fadeOut"
        };

        // set vex theme
	    vex.defaultOptions.className = 'vex-theme-dialog';

        // page exit confirmation
	    Huddle.confirmOnPageExit = function ( e ) {
		    // If we haven't been passed the event get the window.event
		    e = e || window.event;

		    var message = Huddle.translations && Huddle.translations.unsaved_changes
                ? Huddle.translations.unsaved_changes
                : 'It looks like there are unsaved changes on this project.';

		    // For IE6-8 and Firefox prior to version 4
		    if ( e ) {
			    e.returnValue = message;
		    }

		    // For Chrome, Safari, IE8+ and Opera 12+
		    return e.returnValue;
	    };

        $.extend($.easing,
            {
                easeOutCubic: function (x, t, b, c, d) {
                    return c*((t=t/d-1)*t*t + 1) + b;
                }
            }
        );

    });

    $(window).load(function() {
        $('[data-tip]').tipr({
            'speed': 300
        });
    });

    FastClick.attach(document.body);
}(jQuery));