<?php
// load dependencies
require PH_PLUGIN_DIR . '/vendor/autoload.php';

/**
 * Send emails in the background
 */
class PH_Background_Emails extends WP_Background_Process {

	/**
	 * @var string
	 */
	protected $action = 'ph_send_email';

	/**
	 * Task
	 *
	 * Override this method to perform any actions required on each
	 * queue item. Return the modified item for further processing
	 * in the next pass through. Or, return false to remove the
	 * item from the queue.
	 *
	 * @param mixed $item Queue item to iterate over
	 *
	 * @return mixed
	 */
	protected function task( $item ) {
		// Actions to perform

		return false;
	}

	/**
	 * Complete
	 *
	 * Override if applicable, but ensure that the below actions are
	 * performed, or, call parent::complete().
	 */
	protected function complete() {
		parent::complete();

		// Show notice to user or perform some other arbitrary task...
	}

}