<?php
/**
 * Template for the individual project image thumbnail
 *
 * @package     ProjectHuddle
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */
?>

<!-- Comment Item Template -->
<script type="text/template" id="tmpl-project-comment-item">

	<div class="ph-avatar">
		{{{ data.avatar }}}
	</div>

    <div class="ph-item-controls"></div>

	<div class="ph-comment-wrap">
        <div class="ph-comment-item-author">
            {{ data.comment_author }}
        </div>

        <div class="ph-comment-item-date">
            {{ data.date }}
        </div>
        <div class="ph-comment-item-text"></div>
        <div class="ph-edit-textarea"></div>
	</div>
</script>
<!-- Comment Item Template -->

<script type="text/html" id="tmpl-edit-comment-form">
    <div class="ph-edit-content">{{{ data.comment_content }}}</div>
    <button class="ph-button ph-edit-save"><?php _e( 'Save', 'project-huddle' ); ?></button>
    <button class="ph-secondary-link ph-edit-cancel"><?php _e( 'Cancel', 'project-huddle' ); ?></button>
</script>

<script type="text/html" id="tmpl-comment-item-text">
    <div class="ph-comment-item-content">
        {{{ data.comment_content }}}
    </div>
</script>

<script type="text/html" id="tmpl-comment-item-controls">
    <i class="ph-icon ph-edit ion-android-create"></i>
    <i class="ph-icon ph-remove ion-trash-b" data-confirm="<?php _e('Are you sure you want to delete this comment?', 'project-huddle' ); ?>"></i>
</script>