<?php
/**
 * Template for the individual project image thumbnail
 *
 * @package     ProjectHuddle
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */
?>

<script type="text/template" id="tmpl-project-image">
    <div class="ph-project-image-inner">
        <div class="ph-image-comments-container"></div>
        <img class="ph-project-image" src="{{ data.url }}" onload="jQuery(this).fadeIn();" />
        <div class="ph-image-controls"></div>
    </div>
</script>

<script type="text/template" id="tmpl-project-image-zoom">
    <div class="ph-project-zoom-wrap">
        <div class="ph-zoom-percent"><# print( Math.round(data.magnification * 100) ); #>%</div>
        <div class="ph-zoom-in"><i class="ion-android-add-circle"></i></div>
        <div class="ph-zoom-out"><i class="ion-android-remove-circle"></i></div>
    </div>
</script>

<script type="text/template" id="tmpl-image-zoom-controls">
    <div class="ph-zoom-in"><i class="ion-android-add-circle"></i></div>
    <div class="ph-zoom-out"><i class="ion-android-remove-circle"></i></div>
</script>

<script type="text/template" id="tmpl-image-zoom-percent">
    <# print( Math.round(data.magnification * 100) ); #>%
</script>