/**
 * Hook into ControlsView initialize method
 */
wp.hooks.addAction('Huddle.ControlBarView.initialize', function (view) {
    view.phApproveInitialize();
});

/**
 * Extend the original image view
 * Adds new events, subviews and methods
 */
_.extend(Huddle.ControlBarView.prototype, {
    // add approval button sub view
    phApproveInitialize: function () {
        this.views.add('.project-controls', new Huddle.ApproveContainerView({
            model: this.model
        }));
    }
});