/**
 * Hook into ControlsView initialize method
 */
wp.hooks.addAction('Huddle.ImageThumbView.initialize', function( view ){
    view.phApproveListeners();
});

/**
 * Extend the original image view
 * Adds new events, subviews and methods
 */
_.extend( Huddle.ImageThumbView.prototype, {
    phApproveListeners: function() {
        // when image is approved or unapproved, re-render
        this.listenTo( this.model, 'change:approved', this.render );
    }
});