<?php
/**
 * Template Functions
 *
 * @package    project-huddle
 * @subpackage ph-image-approvals
 */

/**
 * Add approved icon to image thumb
 *
 * @param $post object Post object
 *
 * @since 1.1.1
 */
function ph_image_thumb_approval_data( $post ){ ?>
	<?php if ( 'off' != get_post_meta( $post->ID, 'ph_project_approval', true ) ) : ?>
		<# if ( data.approved ) { #>
			<i class="ph-icon ion-android-done ph-approval-indicator"></i>
		<# } #>
	<?php endif; ?>
<?php }
add_action( 'ph_image_thumb_title_before', 'ph_image_thumb_approval_data' );
add_action( 'ph_meta_box_image_title_before', 'ph_image_thumb_approval_data' );