var events = Huddle.ControlBarView.prototype.events;

/**
 * Extend the original image view
 * Adds new events, subviews and methods for ph versions
 */
_.extend( Huddle.ControlBarView.prototype, {

	// Add new events
	events: function () {
		return _.extend({}, events, {
			'click .phv-versions-trigger': 'versionClick'
		});
   },

	/**
	 * Versions click handler
	 *
	 * @param e Click event
	 */
	versionClick: function( e ) {
		// prevent default action
		e.preventDefault();

		// close everything
		Huddle.Event.trigger( 'closeAll', this );
	}
});