<!-- assign dropdown -->
<script type="text/html" id="tmpl-ph-panel-assign">
	<# if ( data.assigned != 0 ) {  #>
		<div class="ph-tooltip-wrap bottom ph-assigned ph-show-info">
			<img src="{{{ data.assigned_model.avatar_urls[96] }}}" class="avatar" />
			<div class="ph-tooltip">
				<span class="ph-subtle"><?php _e( 'Assigned to', 'project-huddle' ); ?></span><br>{{ data.assigned_model.name }}
			</div>
			<i class="ion-chevron-down">
				<svg viewBox="0 0 512 512" id="ion-chevron-down" width="8" height="8"><path d="M256 298.3l174.2-167.2c4.3-4.2 11.4-4.1 15.8.2l30.6 29.9c4.4 4.3 4.5 11.3.2 15.5L264.1 380.9c-2.2 2.2-5.2 3.2-8.1 3-3 .1-5.9-.9-8.1-3L35.2 176.7c-4.3-4.2-4.2-11.2.2-15.5L66 131.3c4.4-4.3 11.5-4.4 15.8-.2L256 298.3z"></path></svg>
			</i>
		</div>
		<# } else { #>
			<div class="ph-tooltip-wrap bottom">
				<div class="ph-assign-user ph-unassigned">
					<i class="ion-plus">
						<svg viewBox="0 0 512 512" id="ion-plus" width="8" height="8"><path d="M448 224H288V64h-64v160H64v64h160v160h64V288h160z"></path></svg>					</i>
				</div><i class="ion-chevron-down">
					<svg viewBox="0 0 512 512" id="ion-chevron-down" width="8" height="8"><path d="M256 298.3l174.2-167.2c4.3-4.2 11.4-4.1 15.8.2l30.6 29.9c4.4 4.3 4.5 11.3.2 15.5L264.1 380.9c-2.2 2.2-5.2 3.2-8.1 3-3 .1-5.9-.9-8.1-3L35.2 176.7c-4.3-4.2-4.2-11.2.2-15.5L66 131.3c4.4-4.3 11.5-4.4 15.8-.2L256 298.3z"></path></svg>
				</i>
				<div class="ph-tooltip">
					<?php _e( 'Assign Someone', 'project-huddle' ); ?>
				</div>
			</div>
		<# } #>
		<div class="ph-assign-options"></div>
</script>
<!-- assign dropdown -->

<!-- individual option -->
<script type="text/html" id="tmpl-ph-single-user-option">
	<div class="ph-single-user-option<# if (data.assigned) { #> ph-assigned-selection<# } #>">
		<span class="ph-avatar">
			<# if ( typeof data.avatar_urls === 'object' &&  typeof data.avatar_urls[96] !== 'undefined' ) { #>
				<img src="{{{ data.avatar_urls[96] }}}" class="avatar" />
			<# } #>
		</span>
		<span class="ph-display-name">{{ data.name }}</span>
		<# if (data.assigned) { #>
			<i class="ion-close ph-close">
				<svg viewBox="0 0 512 512" id="ion-close" width="10" height="10"><path d="M443.6 387.1L312.4 255.4l131.5-130c5.4-5.4 5.4-14.2 0-19.6l-37.4-37.6c-2.6-2.6-6.1-4-9.8-4-3.7 0-7.2 1.5-9.8 4L256 197.8 124.9 68.3c-2.6-2.6-6.1-4-9.8-4-3.7 0-7.2 1.5-9.8 4L68 105.9c-5.4 5.4-5.4 14.2 0 19.6l131.5 130L68.4 387.1c-2.6 2.6-4.1 6.1-4.1 9.8 0 3.7 1.4 7.2 4.1 9.8l37.4 37.6c2.7 2.7 6.2 4.1 9.8 4.1 3.5 0 7.1-1.3 9.8-4.1L256 313.1l130.7 131.1c2.7 2.7 6.2 4.1 9.8 4.1 3.5 0 7.1-1.3 9.8-4.1l37.4-37.6c2.6-2.6 4.1-6.1 4.1-9.8-.1-3.6-1.6-7.1-4.2-9.7z"></path></svg>
			</i>
		<# } #>
	</div>
</script>
<!-- individual option -->