<?php
/**
 * The Template for displaying the image thumb
 *
 * Override this template by copying it to your theme or child theme
 *
 * @package     ProjectHuddle
 * @subpackage  templates
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */
?>

<?php global $post; ?>

<!-- Image Thumb Template -->
<script type="text/template" id="tmpl-image-thumb">
	<span class="ph-nav-thumb" style="background-image: url( {{ data.thumbnail }} );">

		<span class="ph-thumb-details">
			<span class="ph-thumb-detail ph-thumb-comment">
				<i class="ph-icon ion-chatbubble"></i> {{ data.comment_count }}
			</span>

			<span class="ph-thumb-detail ph-thumb-date">
				<i class="ph-icon ion-android-time"></i> {{ data.date }}
			</span>
		</span>

	</span>

	<span class="ph-thumb-title">
		<?php do_action( 'ph_image_thumb_title_before', $post ); ?>

		<span class="ph-thumb-name">
			{{ data.title }}
		</span>

		<?php do_action( 'ph_image_thumb_title_after', $post ); ?>
	</span>
</script>
<!-- Image Thumb Template -->